// todo:
// offset 0x1cb9(slot 3), bit 4 ON force Narshe song
// offset 0x1cad(slot 3), bit 7 ON make control of AS avail.
// offset 0x1cd8(slot 3), bit 1 ON make "cinema black bar" in town
// offset 0x1c94(slot 3), bit 7 ON make airship change to FALCON
// offset 0x1c93(slot 3), bit 6 ON make continent disapear (WOB)
// offset 0x1c93(slot 3), bit 7 ON Floating continent unselectable from AS
//            but if bit 6 is OFF and 7 OFF, still unselectable
// offset 0x08ed(slot 1), the way Cid's going to bed!!
// offset 0x09d0(slot 1), cid's health on deserted island
// offset 0x0896(slot 1), bit 3 ON cid's fine, stay on bed
// offset 0x08ec(slot 1), bit 7 OFF cid is gone (hacking), cid is healthy (normal)

/*
Lord J's
              _/_/_/  _/_/_/  _/_/_/_/_/_/_/
             _/      _/        _/  _/  _/
            _/_/    _/_/      _/  _/  _/
           _/      _/        _/  _/  _/
          _/      _/      _/_/_/_/_/_/_/   SRAM hacker

Project started january 1st 1998
Project constist of hacking the .srm file generated by the emulator using
Final Fantasy 3. In other words, in configure your saved games!



What it does:
-divide the SRAM file into 3 separate game slots for easy to use DOS (sig) UI
-calculate the check sum after hacking
-change, max out, copy and saves characters data
-edit gold, steps, time, swrd tech, lores, dances, max-out rages, item list

What it will hack:
-everything that concern a player's stats
-everything that relates to numeric values: gold, % of learning spell
-each character's apearance, mug and name
-lists: items, magic, rare, rage, lore

Bugs:
-beta tester Jumper did report major bugs, it seems that this utility
 is know 99% free of bugs, but no ones perfect...

Not decoded:
-five upper bits of msB of gotten espers (since 27 espers gettable)
-seven bits of status part b
-illegal rare items, 4 bits of msB
-bit#3, raster edition
-air ship bits
-probably quanty of item list is 255, not 256...
 and 256th item type as another function
 (empty x99? not likely)
-two msbits of airship/shop selection, aka leo & kefka, dunno...
 (presence of players on airship not added, FF3 does not map players
  other than those "getable")
-garbage bits: gold, steps, time --> wasted bits, probably...


Version 1: programmer's edition

Version 2: beta version: player editor
   temporary menus finished
   new commands like sprite editor, status bits, spare bytes,

revision 2b: decoding rest of data in slot: magic,steps,gold,raster org.,
   save pnt,lore,rage,mtek,sw tec,blitz,rare,esper,dance,quest

Version 3: final version:
   71% of gameslot decoded, all features implemented
   some data decoded not usefull (windows colors, battle speed...)
   rest of data not decoded may include airship location, xy location on
   map, deeds, chest states, ect.
   bug: generates error at offset 0x13d6 (+1) when loading -> found it! sramdata's
   parameter 'xtradata' messed up slot no 2, why ????

End of project: May 14 1998



Redirection of project: November 22 1998, Jumper is a new maintainer of the code

The final plain DOS version probably will be #4. Jumper is porting it to DJGPP.

Version 4: resurection
   revision 4a:
      * FF3H goes beta again due to compiler/major code changes
      * Code is cleaned, project is ported to DJGPP.
      * No major bugs have been detected and no new menus up yet.
   
   revision 4b: revamped this header
      * removed 'modified data' warning (kinda annoying) added new menus not 
        implemented in version 4a
      * forgotten those poor little espers in 4a
      * nb saves editable
      * overworld warp, airship credit goes to CzarDragon for save, airship & 
        warp offsets

Version 5: Airship fix & others (Lord J) 2004/02/27
   * bit 1 of offset 2231(dec)/0x8B7 now controled by app. (airship visible)
   * corrected clreol to clreol() when pasting character
   * no more silly .hak file, make a .bk backup file and directly modify .srm
   * fancy end credits from FF4H

-------------------------------------------
-------------------------------------------

Disclamer:

"Final Fantasy 3"(R) and all occurence of related context
to its sotfware are registered trademarks of Square Co., Ltd.
The programmers of this utility are not affiliated with Square Co. and
are not responsible for any loss or damage of material/sofware of the user.

If you do not agree with this disclaimer, do not use this utility (ff3h)


-------------------------------------------
-------------------------------------------
*/
#include <iostream.h>
#include <STRING.H>
#include <stdlib.h>
#include <stdio.h>
#include <fstream.h>
#include <conio.h>
#include <assert.h>
#include <dos.h>

#ifndef endl
#define endl "\n\r"
#endif

#define K_ESCAPE 27
#define K_BACKSPACE 8

#define APP_VERSION  "<Release version 5>"

const unsigned char BTL_MN1 =0;
const unsigned char BTL_MN2 =1;
const unsigned char BTL_MN3 =2;
const unsigned char BTL_MN4 =3;

const unsigned char EQ_SWRD =0;
const unsigned char EQ_SHLD =1;
const unsigned char EQ_HELM =2;
const unsigned char EQ_ARMR =3;
const unsigned char EQ_REL1 =4;
const unsigned char EQ_REL2 =5;

const unsigned char STAT_A  =0;
const unsigned char STAT_B  =1;
const unsigned char VIGOR   =2;
const unsigned char SPEED   =3;
const unsigned char STAMINA =4;
const unsigned char MAGPOW  =5;
const unsigned char ESPER   =6;
const unsigned char PROF1   =7;
const unsigned char PROF2   =8;

typedef unsigned char data;
const long maxdata = 36000lu;
const int  max_slots = 3;
const int  max_magic = 54;          // 54 spells
const int  slot1_offset = 0x0;
const int  slot2_offset = 0xA00;
const int  slot3_offset = 0x1400;
const int  slot_lenght = 0xA00;

// 16 official players + 2 customizable players
const int  nb_players_menu = 18;
const int  nb_players = 16;         // 16 official players
const int  nb_mgc_users = 12;       // 12 magic users

// the first 592 bytes cover character's abilities
const int  car_info_lenght = 37;    // 37 bytes X 16 players

const int  raster_offset  = 592;    // setup of active party(ies)
const int  gold_offset  = 608;      // gold pieces
const int  gtime_offset = 611;      // game time
const int  steps_offset = 614;      // steps
const int  itm_lst_offset = 617;    // possessed items
const int  itm_qty_offset = 873;    // quantity of items
// possessed espers
const int  esp_list_offset = 1129;  // four bytes, switch on/off
const int  magic_offset = 1134;     // learn % of magic X 12

// not decoded 1782, 1784 thru 1831

const int  swrdt_offset = 1783;     // swordtech abil.
const int  blitz_offset = 1832;     // blitz abil.
const int  lores_offset = 1833;     // lores abil.
const int  rages_offset = 1836;     // rages abil.
const int  dance_offset = 1868;     // dance abil.

const int  nb_saves_offset = 1991;  // number of saves, CzarDragon credit
const int  act_memb_offset = 2268;  // active members (shop selection), 2 bytes, CzarDragon credits, lsb byte1 is Terra
const int  act_memb2_offset = 2270; // active members (airship selection), 2 bytes, lsb byte1 is Terra
const int  map_xy_offset = 2400; // XY location on overworld, 2 bytes, CzarDragon credit
const int  ship_xy_offset = 2402;   // XY location of airship, 2 bytes, CzarDragon credit


// not decoded 1869 thru end (2560)

// decoded but not implemented yet:
const int  actgrp_offset = 1133;    // active group, CzarDragon credit


// sword tech name for FF6 CzarDragon credit
const int  swtk_name_offset = 1784; // 48 bytes

const int  btlspeed_offset = 1869;  // mess. and btl speed, 3bits: 6->4 lsb=btl, 2->0 msb=mess
                                    // value from 1 to 6 = 0 to 5
                                    // bit 7 = cmd.set, 1 = short; bit 3 = bat. mode, 1 = wait
const int  wallpaper_offset = 1870; // forest, chocobo, stone, ect., bit 0 -> 3
                                    // gauge off, sound mono, cursor memory, reequip empty, bit 4->7 set to 1

const int  dummy1_offset = 1871;    // ????     when dummy1 to 5 + config1 is set to ff, all key becomes down key
const int  dummy2_offset = 1872;    // ????
const int  dummy3_offset = 1873;    // ????
const int  dummy4_offset = 1874;    // ????
const int  dummy5_offset = 1875;    // ????
const int  config1_offset = 1876;   // about single/multiple cntrl, mag. order, color "arrow" pointer
const int  fontcolor1_offset = 1877; // 00 = blue, red doesnt work
const int  fontcolor2_offset = 1878; //

// this is probably coded on 12 bits, it won't be tested yet...
const int  border1wp1_offset = 1879; // 1st color pntr, 00 = is blue (border part 1, wallpaper no 1)
const int  border2wp1_offset = 1880; // " 00 = is red
const int  border3wp1_offset = 1881; // 2nd color pointer
const int  border4wp1_offset = 1882; // 2nd color pointer
const int  border5wp1_offset = 1883; // 3nd color pointer
const int  border6wp1_offset = 1884; // 3rd color pointer
const int  border7wp1_offset = 1885; // 4rd color pointer
const int  border8wp1_offset = 1886; // 4rd color pointer
const int  border9wp1_offset = 1887; // 5rd color pointer
const int  border10wp1_offset = 1888; // 5rd color pointer
const int  border11wp1_offset = 1889; // 6rd color pointer
const int  border12wp1_offset = 1890; // 6rd color pointer
const int  border13wp1_offset = 1891; // 7th color pointer
const int  border14wp1_offset = 1892; // 7th color pointer


// 1893 thru 1906 wallparer 2
// 1907 thru 1920 wallparer 3
// 1921 thru 1934 wallparer 4
// 1935 thru 1948 wallparer 5
// 1949 thru 1962 wallparer 6
// 1963 thru 1976 wallparer 7
// 1977 thru 1990 wallparer 8
// those "illegal" wp may just be data representing something else in the game...


const int  test_offset = 2404;  // 2403,2418 sp warp ; 2418,1428 sprites
const int  test2_offset = 2405; // 2495,2559

const unsigned char tester = 0x76;

// random, semi-decoded data or not implemented
const int  airship_offset = 2231;   // Lord J, CzarDragon credit
                                    // bit 0: WoR: 0=sad song, 1=norm.song
                                    // bit 1: airship visibility
                                    // bit 2: 1==coin toss cutscean/crashed
                                    // bit 3: start w/ Veldt Music
                                    // bit 4: ?
                                    // bit 5: ?
                                    // bit 6: ?
                                    // bit 7: 1=is a save point
const int  sound_at_startup_offset = 2230; // 99$ = save pnt snd
const int  rare_items_offset = 2234;       // 3 bytes, rare items: 24 items, list is 20 long in game, 4 items are "illegal"

const int  world_offset = 2404;     // offset 2405 was set to 32
                                    // 00 is in balance world, 01 is in world of ruin,
                                    // 02 air ship, serpent trench????
                                    // 03 biz, enemies, tent south, warp to floating isl. cinema, ect., airship battle
                                    // 04 tomb battle bkgnd, no warp, 05 no nothing, 06 "semi" stalled airship
                                    // 07 airship casino deck,
                                    // 09 team splitup (banon) scenario, 0a, "fake" airship
                                    // 0b overwold balance, sabin scenario or doesnt affect?
                                    // 0c casino deck fake airship,
                                    // 0d end of world setup on airship
                                    // 0e,10 chocobo stable, warp to last caverm
                                    // 0f s.fig house warp, blocked
                                    // 75 imperial camp


const int  overworld_palette = 2416;// not confirmed yet
const int  special_warp_offset = 2495;
                                    // 00 = normal, 01 = lete river scenario w/ Banon!,
                                    // 03,02,3f,80,8f,99 = freeze,
                                    // 88 = walk around in spiral!,9f = air ship takeoff +freeze
                                    // 7f = crash

const int  x1_sp_offset = 2496;     // x offset at save point, add = right off., subs = left off.
const int  y1_sp_offset = 2497;     // y offset at save point, add = down off., subs = up off.




const int  name_lenght = 6;


const int bytesize = sizeof(char);
const int wordsize = 2;
const int save = 1;
char bytecontent;
unsigned int wordcontent;
int errorlevel = 0;



char equip_type[6][10] = {"sword","shield","helmet","armor","relic#1","relic#2"};
//char things_type[19][20] =
char *things_type[21] =
              {"Dirks","Swords","Lances","Shadow\'s dirks","Knives",
               "Rods","Brushes","Stars","Specials","Cards",
               "Claws","Shields","Helmets","Armors","Tools",
               "Skeens","Relics","Items","\0"};

int  wpnoffset[19] = {9,28,36,42,50,60,64,67,76,82,89,104,131,162,170,
            175,230,254,255};

//char magic_type[3][12] = {"Black magic","Grey magic","White magic"};
char *magic_type[3] = {"Black magic","Grey magic","White magic"};
int  magicoffset[3]    = {23,44,max_magic};


char btl_slt[4][2] = {"1","2","3","4"};
//char byte_data[9][20] =
char *byte_data[9] =
        {"status_a","status_b","vigor","speed","stamina",
         "magic power","esper","profile byte #1","profile byte #2"};
char state[2][5] = {"OFF\0","ON\0"};
char ttruth[2][10]  = {"FALSE\0","TRUE\0"};
char row[2][7] = {"FRONT\0","BACK\0"};

char lores_list[24][16] =  {
                  "Condemned","Roulette","Clean Sweep","Aqua Rake",
                  "Aero","Blow Fish","Big Guard","Revenge",
                  "Pearl Wind","L.5 Doom","L.4 Flare","L.3 Muddle",
                  "Reflect???","L.? Pearl","Step Mine","Force field",
                  "Dischord","Sour Mouth","Pep up","Rippler",
                  "Stone","Quasar","Grand Train","Exploder"
               };

char temp[32] = "                   \0";

void downconvert(const unsigned char *, const int,unsigned char *);
void upconvert(const unsigned char *, const int,unsigned char *);
char* decodebtl(const unsigned char);
char* decodeitem(const unsigned char);
char* decodeact(const unsigned char);
char* decodecar(const unsigned char);
char* decodeesp(const unsigned char);
int bit_detect(const unsigned char,unsigned int);
unsigned char bit_change(const unsigned char,unsigned int,unsigned int);
unsigned char bit_toggle(const unsigned char,unsigned int);
void dispEndCreditsFancy(void);

//-----------------------
//-----------------------
//  this function decodes text included in SRAM, which is the same format
//  as battle or menu text
//  (occurence of battle or menu text through the ROM is coded this way too)
//  project viewrom uses this code
void downconvert(const unsigned char *input, const int lenght, unsigned char *output)
{
   int ii;
   for (ii=0; ii< lenght; ii++)
   {  // for the capital letters:
      if ((input[ii] <=0x99) && (input[ii] >=0x80))
      {
          output[ii]=input[ii]-0x3f;
      }
      // for the small caps:
      else if ((input[ii] <=0xB3) && (input[ii] >=0x9A))
      {
          output[ii]=input[ii]-0x39;
      }
      // for the numerals:
      else if ((input[ii] <=0xBD) && (input[ii] >=0xB4))
      {
          output[ii]=input[ii]-0x84;
      }
      else if (input[ii] == 0xBE) output[ii]=input[ii]-0x9D; // !
      else if (input[ii] == 0xBF) output[ii]=input[ii]-0x80; // ?
      else if (input[ii] == 0xC0) output[ii]=input[ii]-0x91; // /
      else if (input[ii] == 0xC1) output[ii]=input[ii]-0x87; // :
      else if (input[ii] == 0xC2) output[ii]=input[ii]-0xA0; // "
      else if (input[ii] == 0xC3) output[ii]=input[ii]-0x9C; // '
      else if (input[ii] == 0xC4) output[ii]=input[ii]-0x97; // -
      else if (input[ii] == 0xC5) output[ii]=input[ii]-0x97; // .
      else if (input[ii] == 0xC6) output[ii]=input[ii]-0x98; // ,
//    else if (input[ii] == 0xC7) output[ii]=input[ii]-0x; // ...
      else if (input[ii] == 0xC8) output[ii]=input[ii]-0x8D; // ;
      else if (input[ii] == 0xC9) output[ii]=input[ii]-0xA6; // #
      else if (input[ii] == 0xCA) output[ii]=input[ii]-0x9F; // +
      else if (input[ii] == 0xCB) output[ii]=input[ii]-0xA3; // (
      else if (input[ii] == 0xCC) output[ii]=input[ii]-0xA3; // )
      else if (input[ii] == 0xCD) output[ii]=input[ii]-0xA8; // %
      else if (input[ii] == 0xCE) output[ii]=input[ii]-0x50; // ~
      else if (input[ii] == 0xCF) output[ii]=input[ii]-0xA5; // *
      else if (input[ii] == 0xD2) output[ii]=input[ii]-0x95; // =

      else if (input[ii] == 0xff) output[ii]=char(249); // marks end of line, prints a bullet 

      else output[ii] = char(250);  // mark NULL character, prints a 
   }
}



//-----------------------
//  this function codes ASCII text to the format used with battle/menu text
void upconvert(const unsigned char *input, const int lenght, unsigned char *output)
{
   for (int ii=0; ii<lenght; ii++)
   {  // for the capital letters:
      if ((input[ii] <=(0x99-0x3f)) && (input[ii] >=(0x80-0x3f)))
      {
         output[ii]=input[ii]+0x3f;
      }
      // for the small caps:
      else if ((input[ii] <=(0xB3-0x39)) && (input[ii] >=(0x9A-0x39)))
      {
          output[ii]=input[ii]+0x39;
      }
      // for the numerals:
      else if ((input[ii] <=(0xBD-0x84)) && (input[ii] >=(0xB4-0x84)))
      {
          output[ii]=input[ii]+0x84;
      }
      else if (input[ii] == '!') output[ii]=input[ii]+0x9D; // !
      else if (input[ii] == '?') output[ii]=input[ii]+0x80; // ?
      else if (input[ii] == '/') output[ii]=input[ii]+0x91; // /
      else if (input[ii] == ':') output[ii]=input[ii]+0x87; // :
      else if (input[ii] == '"') output[ii]=input[ii]+0xA0; // "
      else if (input[ii] == '\'') output[ii]=input[ii]+0x9C; // '
      else if (input[ii] == '-') output[ii]=input[ii]+0x97; // -
      else if (input[ii] == '.') output[ii]=input[ii]+0x97; // .
      else if (input[ii] == ',') output[ii]=input[ii]+0x98; // ,
//    else if (input[ii] == 0xC7) output[ii]=input[ii]+0x; // ...
      else if (input[ii] == ';') output[ii]=input[ii]+0x8D; // ;
      else if (input[ii] == '#') output[ii]=input[ii]+0xA6; // #
      else if (input[ii] == '+') output[ii]=input[ii]+0x9F; // +
      else if (input[ii] == '(') output[ii]=input[ii]+0xA3; // (
      else if (input[ii] == ')') output[ii]=input[ii]+0xA3; // )
      else if (input[ii] == '%') output[ii]=input[ii]+0xA8; // %
      else if (input[ii] == '~') output[ii]=input[ii]+0x50; // ~
      else if (input[ii] == '*') output[ii]=input[ii]+0xA5; // *
      else if (input[ii] == '=') output[ii]=input[ii]+0x95; // =
      else if (input[ii] == 0x00) output[ii]=input[ii];

      else if (input[ii] == ' ') output[ii]=0xFF; // the space bar
      else if (input[ii] == 0xFA) output[ii]=0x00; // the 
      else if (input[ii] == 0xF9) output[ii]=0xFF; // the 

      else { output[ii] = char(0XFF); }  // did not check, may not occur...
   }
}

//-----------------------
// this function decodes a byte used to represent one
// of the four attack command of the hacked player
char* decodebtl(const unsigned char b)
{
   char btl[0x24][16] =
   {
      "Fight","Item","Magic","empty",
      "Morph","Steal","Capture","SwrdTech",
      "Throw","Tools","Blitz","Runic",
      "Lore","Sketch","Control","Slot",
      "Rage","Leap","Mimic","Dance",
      "Row","Def","Jump","Xmagic",
      "GPRain","Summon","Health","Shock",
      "Possess","MagiTek","<empty>","dummy\0"
   };

   if (b<31) strcpy(&temp[0],btl[b]);
   else if (b==255) strcpy(&temp[0],btl[30]);
   else strcpy(&temp[0],btl[31]);
   return &temp[0];

}


//-----------------------
// this function decode a byte representing one
// of the 256 items
char* decodeitem(const unsigned char i)
{
   char itm[256][32] =
   {
// Dirks
   "dirk","mithril knife","gardian","air lancet",
   "thief knife","assasin","man eater","sword breaker",
   "gradeus","valiant knife",

// Swords
   "mithril blade","regal cutlass",
   "rune edge","flame sabre","blizzard","thunder blade",
   "epee","break blade","drainer","enhancer",
   "crystal","falchion","soul sabre","ogre nix",
   "excalibur","sciminar","illumina","ragnarok",
   "atma weapon",

// Lance
   "mithril pike","triden","stout spear",
   "partisan","pearl lance","gold lance","aura lance",
   "imp halberd",

// Shadow's dirks
   "imperial","kodachi","blossom",
   "hardened","striker","stunner",

// Knives
   "ashura",
   "kotetsu","forged","tempest","murasame",
   "aura","strato","sky render",

// Rods
   "heal rod",
   "mithril rod","fire rod","ice rod","thunder rod",
   "poison rod","pearl rod","gravity rod","punisher",
   "magus rod",

// Brushes
   "chocobo brush","DaVinci brush","magical brush",
   "rainbow brush",

// Stars
   "shuriken","ninja stars","tack stars",

// Special
   "flail","full moon","morning star","boomerang",
   "rising sun",
   "hawk eye","bone club","sniper","wing edge",

// Cards
   "cards","darts","doom darts","trump",
   "dice","fixed dice",

// Claws
   "metal knuckle","mithril claw",
   "kaiser","poison claw","fire knucle","dragon claw",
   "tiger fangs",

// Shields
   "buckler","heavy shield","mithrild shield",
   "gold shield","aegis shield","diamond shield","fire shield",
   "ice shield","thunder shield","crystal shield","gengi shield",
   "tortoise shield","cursed shield","paladin shield","force shield",

// Helmets
   "leather hat","hair band","plumed hat",
   "beret","magus hat","bandana","iron helmet",
   "coronet",
   "bard's hat","green beret","head band","mithril helmet",
   "tiara","gold helmet","tiger mask","red cap",
   "mystery veil","circlet","regal crown","diamond helmet",
   "dark hood","crystal helmet","oath veil","cat hood",
   "genji helmet","thornlet","titanium",

// Armors
   "leather armor",
   "cotton robe","kungfu suit","iron armor","silk robe",
   "mithril vest","ninja gear","white dress","mithril mail",
   "gaia gear","mirage vest","gold armor","power sash",
   "light robe","diamond vest","red jacket","force armor",
   "diamond armor","dark gear","tao robe","crystal mail",
   "czarina gown","gengi armor","imp armor","minerva",
   "tabby suit","chocobo suit","moogle suit","nutkin suit",
   "behemot suit","snow muffler",

// Tools
   "noise blaster","bio blaster",
   "flash","chain saw","debilitator","drill",
   "air anchor","auto crossbow",

// Skeans
   "fire skean","water edge",
   "bolt edge","inviz edge","shadow edge",

// Relics
   "goggles",
   "star pendant","peace ring","amulet","white cape",
   "jewel ring","fairy ring","barrier ring","mithril glove",
   "gard ring","running shoes","wall ring","cherub down",
   "cure ring","true knight","dragoon boots","zephir cape",
   "czarina ring","cursed ring","earring","atlas armlet",
   "blizard orb","rage ring","sneak ring","pod bracelet",
   "hero ring","ribon","muscle belt","crystal orb",
   "gold hairpin","economizer","thief glove","gauntlet",
   "genji glove","hyper wrist","offering","beads",


   "black belt","coin toss","fake mustache","gem box",
   "dragon horn","merit award","memento ring","safety bit",
   "relic ring","moogle charm","charm bangle","marvel shoes",
   "back gard","gale hairpin","sniper sight","exp. egg",
   "tintinabar","sprint shoes",

// Items
   "rename card","tonic",
   "potion","x-potion","tincture","ether",
   "x-ether","elixir","megalixir","fenix down",
   "revify","antidote","eye drop","soft",
   "remedy","sleeping bag","tent","green cherry",
   "magicite","super ball","echo screen","smoke bomb",
   "warp stone","dried meat",
   "<empty>\0"
   };

   strcpy(temp,&itm[i][0]);
   return temp;
}

//-----------------------
//  this function, decodes a byte representing the actor's name
//  What is an actor? Let say that FF3 is an opera piece, each actor as a different
//  role in the play, well it's the same with FF3. When Terra turn into an esper,
//  its actor number 0 who participate in the cinema sequence, and the way that this
//  actor looks may vary (that's the costume in the opera play example). In this case,
//  actor 0 (Terra) may "wear" costume #00 (normal Terra sprite) or #18 (esper sprite)
char* decodeact(const unsigned char c)
{
   char ch;
   if (c>=64)
      ch=64;
   else
      ch = c;

   // I suspect that there is only 64 "actors"
   char act[256][12] =
         {  "Terra","Locke","Cyan","Shadow","Edgar","Sabin",
            "Celes","Strago","Relm","Setzer","Mog","Gau",
            "Gogo","Umaro","Banon","Leo","Ghost#1","Ghost#2",
            "Kupek","Kupop","Kumama","Kuku","Kutan","Kupan",
            "Kushu","Kurin","Kuku","Kamog","Fake Mog","?????",
            "Maduin","?????","Wedge","Vicks",
            "<not def>","<not def>","<not def>","<not def>",
            "<not def>","<not def>","<not def>",
            "Kefka","Kefka","Kefka","Kefka","Kefka","Kefka",
            "Kefka","Tork","Jade","Custer","Fabian","Drake",
            "Sara","Case","Siele","Ray","Reiker","Lance",
            "Bob","Pepper","Tau","Victor","Ho","<NOT DEF>\0"
         };
/*
   char ret_str[12];
   strcpy(&ret_str[0],&act[ch][0]);
   if ( (ch>=34)&&(ch<=47) || ch==29 || ch==31 || c>=64)
      sprintf(&ret_str[0],"%s(%d)\0",&act[ch][0],c);
   return ret_str;
*/
   strcpy(&temp[0],&act[ch][0]);
   if ( (ch>=34)&&(ch<=47) || ch==29 || ch==31 || c>=64)
      sprintf(&temp[0],"%s(%d)\0",&act[ch][0],c);
   return temp;
}



//-----------------------
//  this function, decodes a byte representing the sprite used
//  What is a character? please refer to the opera analogy explaned above
char* decodecar(const unsigned char c)
{
   int cc = c;
   if (c>=53) cc=53;

   // Didn't find alot, that's about all there is in the game
   // the rest is either buggy or demi-sprites (statues, birds...)
   char car[256][20] =
         {  "Terra","Locke","Cyan","Shadow","Edgar","Sabin",
            "Celes","Strago","Relm","Setzer","Moogle","Gau",
            "Gogo","Umaro","Imperial soldier","Imp","Leo","Banon",
            "Terra(Esper)","Merchant","Ghost","Kefka","Gesthal","Elder",
            "Man(Imp.Sold.)","Interceptor","Celes(dressed)","Scholar","Draco","Arvis",
            "Returner","Ultros","Clean Gau","?","Counselor","Clide",
            "Old lady","Lady","Boy","?","?","?",
            "?","?","?","?","?","?",
            "?","?","?","?","?","?\0"

         };
// return &car[cc][0];
   strcpy(&temp[0],&car[cc][0]);
   return temp;
}


//-----------------------
//  this function decodes a byte that represents an esper
char* decodeesp(const unsigned char c)
{
   int cc = c;
   if (c>=53) cc=53;
   strcpy(&temp[0],"No esper");
   if (c==0xff) return &temp[0];
   char car[256][20] =
         {  "Ramuh","Ifrit","Shiva","Siren","Terrato","Shoat",
            "Maduin","Bismark","Stray","Palidor","Tritoch","Odin",
            "Raiden","Bahamut","Alexandr","Crusader","Ragnarok","Kirin",
            "Zone seek","Phantom","Carbunkl","Sraphim","Golem","Unicorn",
            "Fenrir","Starlet","Phoenix","\"Wing song\"","<water edge>","\"Aria\"",
            "<bolt edge>","\"Sonata\"","<dispatch>","<slash>","<quadra slam>","<empower>",
            "<stunner>","<quadra slice>","<cleave>","<pummel>","?","?",
            "<Fire dance>","<mantra>","<air blade>","<spiraler>","<bum rush>","<air slash>",
            "?","?","?","?","?","?\0"

         };
// return &car[cc][0];
   strcpy(&temp[0],&car[cc][0]);
   return temp;
}


//-----------------------
//  this decodes a byte representing a normal magic spell
char* decodemagic(const unsigned char m)
{
   char magic[max_magic][7] =
            {  "fire","ice","bolt","poison","drain",
               "fire2","ice2","bolt2","bio",
               "fire3","ice3","bolt3","break",
               "doom","pearl","flare","demi",
               "quartr","x-zone","meteor","ultima",
               "quake","w wind","merton","scan",
               "slow","rasp","mute","safe",
               "sleep","muddle","haste","stop",
               "bserk","float","imp","rflect",
               "shell","vanish","haste2","slow2",
               "osmose","warp","quick","dispel",
               "cure","cure2","cure3","life",
               "life2","antdot","remedy","regen","life3"
            };
   strcpy(&temp[0],&magic[m][0]);
   return temp;

// return &magic[m][0];
}


//-----------------------
//  returns the state of bit number <bitnb> of byte <byte> (1=true, 0=false)
int bit_detect(const unsigned char byte,unsigned int bitnb)
{
   if ((byte>>bitnb)&0x01) return 1;
   return 0;
}

//-----------------------
//  force the state of bit number <bitnb> of byte <byte> to state <state>
//  (1=true, 0=false)
unsigned char bit_change(const unsigned char byte,unsigned int bitnb,unsigned int state)
{
   unsigned char ret;
   if(state)
      ret = (byte | (1<<bitnb));
   else
      ret = (byte & (0xFF^(1<<bitnb)));
   return ret;
}

//-----------------------
//  toggle the state of bit number <bitnb> of byte <byte> (1=true, 0=false)
unsigned char bit_toggle(const unsigned char byte,unsigned int bitnb)
{
   return (byte ^ (0x01<<bitnb));
}









//-----------------------
//-----------------------
//  this class extract all the data used by a slot from the file
//  various methods for this class decodes specific data
//  What is a gameslot? It's a saved game, FF3 lets you save up to 3 games
//  in the SRAM, (unlike FF2/4j which was 4)
class gameslot
{
private:
   gameslot() {}


public:
   unsigned int  checksum;
   unsigned long gold_tot, steps_tot;

   unsigned char slotdata[slot_lenght];


   gameslot(const long, ifstream &);
   gameslot(const gameslot&);
   int  operator ==(const gameslot&);
   void operator =(const gameslot);
   void showgs();
   void correct_chksum();
   void save_player(unsigned char*,unsigned char*,int);
   int  save_misc();
   void print2file(ofstream &);
   void view_itm_lst();
   void max_out_items();
   void get_items();
   void change_swrdtech();
   void change_blitz();
   void change_lores();
   void get_rages();
   void change_dances();
   void get_rare_items();
   void change_espers();

   unsigned char raster_info[nb_players];
   unsigned char gold[3];
   unsigned char gtime[3];
   unsigned char steps[3];
   unsigned char itm_list[256];
   unsigned char itm_quty[256];
   unsigned char swrdtech;
   unsigned char dances;
   unsigned char blitz;
   unsigned char lores[3];
   unsigned char rages[32];
   unsigned char rare_items[3];
   unsigned char espers[4];
   unsigned char nb_saves;
   unsigned char active_members[2];
   unsigned char map_xy[2];
   unsigned char airship_xy[2];
   unsigned char airship_state;

};
// end of gameslot class





//-----------------------
//  main constructor
//  used to copy one of the 3 slots of the file in a buffer
gameslot::gameslot(const long offset,ifstream & sf)
{
      int i;
   unsigned char msb_chks,lsb_chks;

   sf.seekg((offset), ios::beg);
   for (i = 0; i<slot_lenght; i++)
   {
      sf.read(&bytecontent,bytesize);
      slotdata[i] = bytecontent;
   }
// cprintf(" %x ",slotdata[2518]);getch(); // the last bug

   sf.seekg((raster_offset+offset), ios::beg);
   for (i=0; i<nb_players; i++)
   {
      sf.read(&bytecontent,bytesize);
      raster_info[i]=bytecontent;
   }


   sf.seekg((gold_offset+offset), ios::beg);
   for (i=0; i<3; i++)
   {
      sf.read(&bytecontent,bytesize);
      gold[i]=bytecontent;
   }

   sf.seekg((gtime_offset+offset), ios::beg);
   for (i=0; i<3; i++)
   {
      sf.read(&bytecontent,bytesize);
      gtime[i]=bytecontent;
   }

   sf.seekg((steps_offset+offset), ios::beg);
   for (i=0; i<3; i++)
   {
      sf.read(&bytecontent,bytesize);
      steps[i]=bytecontent;
   }

   sf.seekg((itm_lst_offset+offset), ios::beg);
   for (i=0; i<256; i++)
   {
      sf.read(&bytecontent,bytesize);
      itm_list[i]=bytecontent;
   }

   sf.seekg((itm_qty_offset+offset), ios::beg);
   for (i=0; i<256; i++)
   {
      sf.read(&bytecontent,bytesize);
      itm_quty[i]=bytecontent;
   }


   sf.seekg((swrdt_offset+offset), ios::beg);
   sf.read(&bytecontent,bytesize);
   swrdtech=bytecontent;

   sf.seekg((blitz_offset+offset), ios::beg);
   sf.read(&bytecontent,bytesize);
   blitz=bytecontent;

   sf.seekg((lores_offset+offset), ios::beg);
   for (i=0; i<3; i++)
   {
      sf.read(&bytecontent,bytesize);
      lores[i]=bytecontent;
   }

   sf.seekg((rages_offset+offset), ios::beg);
   for (i=0; i<32; i++)
   {
      sf.read(&bytecontent,bytesize);
      rages[i]=bytecontent;
   }

   sf.seekg((dance_offset+offset), ios::beg);
   sf.read(&bytecontent,bytesize);
   dances=bytecontent;

   sf.seekg((rare_items_offset+offset), ios::beg);
   for (i=0; i<3; i++)
   {
      sf.read(&bytecontent,bytesize);
      rare_items[i]=bytecontent;
   }

   sf.seekg((esp_list_offset+offset), ios::beg);
   for (i=0; i<4; i++)
   {
      sf.read(&bytecontent,bytesize);
      espers[i]=bytecontent;
   }

   sf.seekg((nb_saves_offset+offset), ios::beg);
   sf.read(&bytecontent,bytesize);
   nb_saves=bytecontent;

   sf.seekg((act_memb_offset+offset), ios::beg);
   for (i=0; i<2; i++)
   {
      sf.read(&bytecontent,bytesize);
      active_members[i]=bytecontent;
   }

   sf.seekg((map_xy_offset+offset), ios::beg);
   for (i=0; i<2; i++)
   {
      sf.read(&bytecontent,bytesize);
      map_xy[i]=bytecontent;
   }

   sf.seekg((ship_xy_offset+offset), ios::beg);
   for (i=0; i<2; i++)
   {
      sf.read(&bytecontent,bytesize);
      airship_xy[i]=bytecontent;
   }


   sf.seekg((airship_offset+offset), ios::beg);
   sf.read(&bytecontent,bytesize);
   airship_state=bytecontent;

   lsb_chks = slotdata[slot_lenght-2];
   msb_chks = slotdata[slot_lenght-1];
   checksum = (msb_chks << 8) | lsb_chks;

   gold_tot = ((unsigned long)(gold[0]) + ((unsigned long)(gold[1]) << 8) + ((unsigned long)(gold[2]) << 16) );
   steps_tot = ((unsigned long)(steps[0]) + ((unsigned long)(steps[1]) << 8) + ((unsigned long)(steps[2]) << 16) );
}

//-----------------------
// this constructor is used to copy a game slot in another slot
gameslot::gameslot(const gameslot &gs)
{
    int i;
   for (i = 0; i<slot_lenght; i++)
      slotdata[i] = gs.slotdata[i];

   checksum = gs.checksum;

   for (i=0; i<256; i++)
   {
      itm_list[i] = gs.itm_list[i];
      itm_quty[i] = gs.itm_quty[i];
   }
}

//-----------------------
// this operator is used to compare 2 slots
int gameslot::operator ==(const gameslot& gs)
{
        int i;
   for (i = 0; i<slot_lenght; i++)
      if (slotdata[i] != gs.slotdata[i]) return 0;

   for (i=0; i<256; i++)
   {
      if (itm_list[i] != gs.itm_list[i]) return 0;
      if (itm_quty[i] != gs.itm_quty[i]) return 0;
   }
   return 1;
}

//-----------------------
//  this operator is used to copy a game slot
void gameslot::operator =(const gameslot gs)
{
      int i;
   for (i = 0; i<slot_lenght; i++)
      slotdata[i] = gs.slotdata[i];

   checksum = gs.checksum;

   for (i=0; i<256; i++)
   {  itm_list[i] = gs.itm_list[i];
      itm_quty[i] = gs.itm_quty[i];
   }
}


//-----------------------
// this method is for trouble shooting purposes only
void gameslot::showgs()
{
   clrscr();
   int adress;
   unsigned int mod;
   int start = 1782;
// int end = slot_lenght;
   int end = 1832;

      int i;
   cprintf("Not decoded yet: slot stuff\n\r");
   cprintf("start: %d, end: %d\n\r",start,end);getch();
   for (i = start; i<end; i++)
   {
      cprintf("%d ",int(slotdata[i]));
//    if (((i-start)%400==0)&&(i-start!=0)) {   getch(); }
   }
   getch();

   start = 1991;
   end = slot_lenght;
   cprintf("\n\r\n\rNot decoded yet: \"deeds\", chests...\n\r");
   cprintf("start: %d, end: %d\n\r",start,end);getch();
   for (i = start; i<end; i++)
   {
      cprintf("%d ",int(slotdata[i]));
//    if (((i-start)%400==0)&&(i-start!=0)) {   getch(); }
   }
   getch();

   cprintf("\n\roffset xy: %d,%d",int(slotdata[x1_sp_offset]),int(slotdata[y1_sp_offset]));
   cprintf("\n\rtest : %d,%d\n\r",int(slotdata[2404]),int(slotdata[2405]));

   cprintf("\n\r** Warning, data that's modified is automaticly updated! **\n\r");
   cprintf(" Do you want to edit a raw hexadecimal data? [y]/[n] ");
   char kp = getche();
   if (kp=='y')
   {
      cprintf("\n\r- Editing raw data - enter adress to edit (0 to 2559): ");
      cin >> adress;
      cprintf("- Old value: %d - enter new value (0 to 255): ",
         int(slotdata[adress]));

      cin >> mod;
      slotdata[adress] = (unsigned char)mod;
      correct_chksum();
   }
   else
   {
      cprintf("\n\r- Request canceled - press a key");
      getch();
   }
}


//-----------------------
// this method corrects the 16 bits check sum at end of this slot after hacking
// for trouble shooting, it doesn't write in the file already
void gameslot::correct_chksum()
{
   unsigned char msb_chks,lsb_chks;
   unsigned int newchecksum = 0ul;

   for (int i = 0; i<(slot_lenght-2); i++)
   {
      newchecksum += slotdata[i];
      newchecksum &= 0xFFFF;
   }
   if (newchecksum==checksum)
      cprintf("\n\rCheck sum ok: %u\n\r",checksum);
   else
   {
      cprintf("\n\r- Changing checksum - old: %u, new: %u\n\r",checksum,newchecksum);
      checksum = newchecksum;
   }
   msb_chks = (checksum >> 8) &0xFF;
   lsb_chks = checksum & 0xFF;

   slotdata[slot_lenght-2] = lsb_chks;
   slotdata[slot_lenght-1] = msb_chks;
   getch();
}


//-----------------------
// (part 1 of 2)
// this method is used to update one slot's data
// it updates one player's data onto THE slot buffer
void gameslot::save_player(unsigned char* pl_,unsigned char* mgc,int pl_id)
{
      int i;
   for (i = 0; i<car_info_lenght; i++)
   {
      slotdata[(pl_id-1)*car_info_lenght+i] = pl_[i];
   }

   if (pl_id<=nb_mgc_users && pl_id !=0)
   {
      for (int j = 0; j<max_magic ;j++)
      {  slotdata[(pl_id-1)*max_magic+magic_offset+j] = mgc[j];  }
   }

   for (i=0; i<nb_players; i++)
   {  slotdata[raster_offset+i] = raster_info[i];  }
}


//-----------------------
// (part 2 of 2)
// this method is used to update one slot's data
// it updates the rest of the data (gold, steps...) onto THE slot buffer
int gameslot::save_misc()
{
   unsigned char msb_chks,lsb_chks;

   gold[2] = (unsigned char)(gold_tot);
   gold[1] = (unsigned char)(gold_tot>>8);
   gold[0] = (unsigned char)(gold_tot>>16);

   steps[2] = (unsigned char)(steps_tot);
   steps[1] = (unsigned char)(steps_tot>>8);
   steps[0] = (unsigned char)(steps_tot>>16);

      int i;
   for (i=0; i<3; i++)
   {
      slotdata[gold_offset+i]=gold[2-i];
      slotdata[gtime_offset+i]=gtime[i];
      slotdata[steps_offset+i]=steps[2-i];
   }

   // updates data
   for (i=0; i<256; i++)
   {
      slotdata[itm_lst_offset+i]=itm_list[i];
      slotdata[itm_qty_offset+i]=itm_quty[i];
   }

   slotdata[swrdt_offset] = swrdtech;

   slotdata[blitz_offset] = blitz;

   slotdata[lores_offset]   = lores[0];
   slotdata[lores_offset+1] = lores[1];
   slotdata[lores_offset+2] = lores[2];

   for (i=0; i<32; i++)
   {
      slotdata[rages_offset+i]=rages[i];
   }

   slotdata[dance_offset] = dances;

   for (i=0; i<3; i++)
   {
      slotdata[rare_items_offset+i]=rare_items[i];
   }


   for (i=test_offset; i<test2_offset/*456*/; i++)
   {
//    slotdata[i]=tester;
   }
   // repere

// slotdata[test_offset]=tester;


   for (i=0; i<4; i++)
   {
      slotdata[esp_list_offset+i]=espers[i];
   }

   slotdata[nb_saves_offset]=nb_saves;

   for (i=0; i<2; i++)
   {
      slotdata[act_memb_offset+i]=active_members[i];
   }

   for (i=0; i<2; i++)
   {
      slotdata[map_xy_offset+i]=map_xy[i];
   }

   for (i=0; i<2; i++)
   {
      slotdata[ship_xy_offset+i]=airship_xy[i];
   }

   slotdata[airship_offset]=airship_state;

   msb_chks = (checksum >> 8) &0xFF;
   lsb_chks = checksum & 0xFF;

   slotdata[slot_lenght-2] = lsb_chks;
   slotdata[slot_lenght-1] = msb_chks;

   correct_chksum();
   return 0;
}



//-----------------------
//  this method is for debug purposes only
//  Take the rest of a sram file and dump it in decimal in a printable
//  file
void gameslot::print2file(ofstream &p)
{
   clrscr();
   delay(500);
        char buff[16],cr = '\n';
   cprintf("Dumping to file\n\r");
   int i;
   for (i = nb_players*car_info_lenght; i<slot_lenght; i++)
   {
      cprintf("%d ",int(slotdata[i]));
      sprintf(&buff[0],"%03d:%04d  ",int(slotdata[i]),i);
      p.write(&buff[0], 10/*sizeof(buff)*/);
      if ((i-nb_players*car_info_lenght)%7==0) p.write(&cr,1);
   }
   getch();
}

//-----------------------
// this method is used to show the menu that allow to change the item list
void gameslot::view_itm_lst()
{
   unsigned char tempbyte=0,tempbyte2=0;
   int count =0;
   int thingcn=0;
   char keyp = ' ';
   clrscr();
   cprintf("** List of items **\n\r\n\r");
   cprintf("Skip list? [y]/[n]: ");
   keyp = getche();
   cprintf("\n\r");
   while((count<=255)&&(keyp!='y'))
   {
      while((int(count)<69*thingcn)&&(thingcn<=19))
      {
         for(int j = 0; j<3; j++)
         {
            gotoxy(j*22+1,wherey());
            cprintf("[%d] %s ",int(count),decodeitem(itm_list[count]));
            gotoxy(j*22+20,wherey());
            cprintf("x%d",int(itm_quty[count]));
            count++;
            if ((count>69*thingcn)&&(count!=0)) break;
            if (count>=255) break;
         }
         cprintf("\n\r");
         if (count>=255) break;
      }
      thingcn++;
      getch();
   }
   int entry;

   cprintf("\n\r- Changing item - Enter new entry (0 to 255): ");
   cin >> entry;
   tempbyte2 = entry & 0xFF;

   cprintf("\n\r- Changing item, current: %s - Enter new entry (0 to 255): ",decodeitem(itm_list[tempbyte2]));
   cin >> entry;
   tempbyte = entry & 0xFF;
   itm_list[tempbyte2] = tempbyte;

   cprintf("\n\r- Changing item quantity - Enter new entry (0 to 99): ");
   cin >> entry;
   tempbyte = entry & 0xFF;
   if (tempbyte>99) tempbyte = 99;
   itm_quty[tempbyte2] = tempbyte;;
}


//-----------------------
// this method is used to get all current item at 99
void gameslot::max_out_items()
{
   for (int a=0; a<256; a++)
   {
      if (itm_list[a] != 255)
         itm_quty[a] = 99;
   }

   gotoxy(1,23);
   cprintf("- Current item list maxed-out - press a key to continue");
   getch();
}


//-----------------------
// this method is used to get all item at 99
void gameslot::get_items()
{
   for (int i=0; i<256; i++)
   {
      itm_list[i] = i;
      itm_quty[i] = 99;
   }
   itm_quty[255] = 0;

   gotoxy(1,23);
   cprintf("- Got all items x99 - press a key to continue");
   getch();
}


//-----------------------
// this method is used to edit the list of sword techniques learned
void gameslot::change_swrdtech()
{
   unsigned char bak = swrdtech;
   char kp = ' ';

   clrscr();
   while (kp!='q')
   {
      clrscr();
      gotoxy(22,1);
      cprintf("** Changing sword techniques ** Press a key to switch");
      gotoxy(1,4);
      cprintf("[a] Dispatch     : %s",state[bit_detect(swrdtech,0)]);
      gotoxy(30,4);
      cprintf("[b] Retort       : %s",state[bit_detect(swrdtech,1)]);
      gotoxy(1,6);
      cprintf("[c] Slash        : %s",state[bit_detect(swrdtech,2)]);
      gotoxy(30,6);
      cprintf("[d] Quadra Slam  : %s",state[bit_detect(swrdtech,3)]);
      gotoxy(1,8);
      cprintf("[e] Empower      : %s",state[bit_detect(swrdtech,4)]);
      gotoxy(30,8);
      cprintf("[f] Stunner      : %s",state[bit_detect(swrdtech,5)]);
      gotoxy(1,10);
      cprintf("[g] Quadra Slice : %s",state[bit_detect(swrdtech,6)]);
      gotoxy(30,10);
      cprintf("[h] Cleave       : %s",state[bit_detect(swrdtech,7)]);

      gotoxy(1,13);
      cprintf("[i] All on");
      gotoxy(30,13);
      cprintf("[j] All off");

      gotoxy(30,15);
      cprintf("[q] Return to sub menu");
      kp = getch();
      switch(kp)
      {
         case 'a':
         {  swrdtech = bit_toggle(swrdtech,0);break;}
         case 'b':
         {  swrdtech = bit_toggle(swrdtech,1);break;}
         case 'c':
         {  swrdtech = bit_toggle(swrdtech,2);break;}
         case 'd':
         {  swrdtech = bit_toggle(swrdtech,3);break;}
         case 'e':
         {  swrdtech = bit_toggle(swrdtech,4);break;}
         case 'f':
         {  swrdtech = bit_toggle(swrdtech,5);break;}
         case 'g':
         {  swrdtech = bit_toggle(swrdtech,6);break;}
         case 'h':
         {  swrdtech = bit_toggle(swrdtech,7);break;}
         case 'i':
         {  swrdtech = 0xFF;break;}
         case 'j':
         {  swrdtech = 0x00;break;}
         case 'q': break;
         default :
         {
            gotoxy(1,24);
            cprintf("\n\r** Invalid entry! Press a key **");
            getch();
            break;
         }
      }
   }
}





//-----------------------
// this method is used to edit the list of blitz learned
void gameslot::change_blitz()
{
   unsigned char bak = blitz;
   char kp = ' ';

   clrscr();
   while (kp!='q')
   {
      clrscr();
      gotoxy(22,1);
      cprintf("** Changing blitz ** Press a key to switch");
      gotoxy(1,4);
      cprintf("[a] Pummel    : %s",state[bit_detect(blitz,0)]);
      gotoxy(30,4);
      cprintf("[b] Aura bolt : %s",state[bit_detect(blitz,1)]);
      gotoxy(1,6);
      cprintf("[c] Suplex    : %s",state[bit_detect(blitz,2)]);
      gotoxy(30,6);
      cprintf("[d] Fire dance: %s",state[bit_detect(blitz,3)]);
      gotoxy(1,8);
      cprintf("[e] Mantra    : %s",state[bit_detect(blitz,4)]);
      gotoxy(30,8);
      cprintf("[f] Air blade : %s",state[bit_detect(blitz,5)]);
      gotoxy(1,10);
      cprintf("[g] Spiraler  : %s",state[bit_detect(blitz,6)]);
      gotoxy(30,10);
      cprintf("[h] Bum rush  : %s",state[bit_detect(blitz,7)]);

      gotoxy(1,13);
      cprintf("[i] All on");
      gotoxy(30,13);
      cprintf("[j] All off");

      gotoxy(30,15);
      cprintf("[q] Return to sub menu");
      kp = getch();
      switch(kp)
      {
         case 'a':
         {  blitz = bit_toggle(blitz,0);break;}
         case 'b':
         {  blitz = bit_toggle(blitz,1);break;}
         case 'c':
         {  blitz = bit_toggle(blitz,2);break;}
         case 'd':
         {  blitz = bit_toggle(blitz,3);break;}
         case 'e':
         {  blitz = bit_toggle(blitz,4);break;}
         case 'f':
         {  blitz = bit_toggle(blitz,5);break;}
         case 'g':
         {  blitz = bit_toggle(blitz,6);break;}
         case 'h':
         {  blitz = bit_toggle(blitz,7);break;}
         case 'i':
         {  blitz = 0xFF;break;}
         case 'j':
         {  blitz = 0x00;break;}
         case 'q': break;
         default :
         {
            gotoxy(1,24);
            cprintf("\n\r** Invalid entry! Press a key **");
            getch();
            break;
         }
      }
   }
}


//-----------------------
// this method is used to edit the list of lores learned
void gameslot::change_lores()
{

   int y = 4, indice_bit;
   unsigned char lorebyte;
   char kp = ' ', letter = 'a';
   while(1)
   {
      clrscr();
      char t_ = ' ';
      while (kp!='Q' && t_!='y')
      {
         y = 4;
         clrscr();
         gotoxy(22,1);
         cprintf("** Changing lores ** Press a key to switch\n\r");
         letter = 'a';
         for (int i = 0; i<3*8; i++, letter++)
         {
            indice_bit = (letter-97)%8;
            if (letter>='a' && letter<='h')
               lorebyte = 0;
            else if (letter>='i' && letter<='p')
               lorebyte = 1;
            else lorebyte = 2;
            if(i%2)
            {
               gotoxy(30,y);
               y++;
            }
            else gotoxy(1,y);
            cprintf("[%c] %12s : %s",letter,&lores_list[i][0],&state[bit_detect(lores[lorebyte],indice_bit)][0] );
         }
         y+=2;
         gotoxy(1,y);
         cprintf("[y] All on");
         gotoxy(30,y);
         cprintf("[z] All off");
         y++;
         gotoxy(30,y);
         cprintf("[Q] Return to sub menu");
         kp = getch();
         {
            if((kp>='a') && (kp<='x'))
            {
               indice_bit = (kp-97)%8;
               if (kp>='a' && kp<='h')
                  lorebyte = 0;
               else if (kp>='i' && kp<='p')
                  lorebyte = 1;
               else lorebyte = 2;
               lores[lorebyte] = bit_toggle(lores[lorebyte],indice_bit);
            }
            else if(kp=='y')
            {
               lores[0] = 0xFF;
               lores[1] = 0xFF;
               lores[2] = 0xFF;
            }
            else if(kp=='z')
            {
               lores[0] = 0x00;
               lores[1] = 0x00;
               lores[2] = 0x00;
            }
            else if(kp=='Q');
            else
            {
               gotoxy(1,24);
               cprintf("\n\r** Invalid entry! Press a key **");
               getch();
            }
         }
      }
      gotoxy(1,24);
      t_ = 'y';
      clrscr();
      if ((t_=='y')||(t_=='n')) break;
   }
}

//-----------------------
// this method is used to get all the rages and to show every monster on the velt
//-----------------------
// a note for a rage byte: not completely decoded
// first i thought a rage was represented by one bit, now i suspect that a
// rage could have two bits or more bits: one for the rage list, another for
// apearance on Veldt
void gameslot::get_rages()
{
   for (int i = 0; i<32; i++)
      rages[i] = 0xff;
}



//-----------------------
// this method is used to edit the list of dances learned
void gameslot::change_dances()
{
   unsigned char bak = dances;
   char kp = ' ';

   clrscr();
   while (kp!='q')
   {
      clrscr();
      gotoxy(22,1);
      cprintf("** Changing dances ** Press a key to switch");
      gotoxy(1,4);
      cprintf("[a] Wind Song    : %s",state[bit_detect(dances,0)]);
      gotoxy(30,4);
      cprintf("[b] Forest Suite : %s",state[bit_detect(dances,1)]);
      gotoxy(1,6);
      cprintf("[c] Desert Aria  : %s",state[bit_detect(dances,2)]);
      gotoxy(30,6);
      cprintf("[d] Love Sonata  : %s",state[bit_detect(dances,3)]);
      gotoxy(1,8);
      cprintf("[e] Earth Blues  : %s",state[bit_detect(dances,4)]);
      gotoxy(30,8);
      cprintf("[f] Water Rondo  : %s",state[bit_detect(dances,5)]);
      gotoxy(1,10);
      cprintf("[g] Dust Requiem : %s",state[bit_detect(dances,6)]);
      gotoxy(30,10);
      cprintf("[h] Snowman Jazz : %s",state[bit_detect(dances,7)]);

      gotoxy(1,13);
      cprintf("[i] All on");
      gotoxy(30,13);
      cprintf("[j] All off");

      gotoxy(30,15);
      cprintf("[q] Return to sub menu");
      kp = getch();
      switch(kp)
      {
         case 'a':
         {  dances = bit_toggle(dances,0);break;}
         case 'b':
         {  dances = bit_toggle(dances,1);break;}
         case 'c':
         {  dances = bit_toggle(dances,2);break;}
         case 'd':
         {  dances = bit_toggle(dances,3);break;}
         case 'e':
         {  dances = bit_toggle(dances,4);break;}
         case 'f':
         {  dances = bit_toggle(dances,5);break;}
         case 'g':
         {  dances = bit_toggle(dances,6);break;}
         case 'h':
         {  dances = bit_toggle(dances,7);break;}
         case 'i':
         {  dances = 0xFF;break;}
         case 'j':
         {  dances = 0x00;break;}
         case 'q': break;
         default :
         {
            gotoxy(1,24);
            cprintf("\n\r** Invalid entry! Press a key **");
            getch();
            break;
         }
      }
   }
}

//-----------------------
// this method is used to get all the "legal" rare items
//-----------------------
// 3 bytes, 3rd byte: the 4 msbits are dummy items
// each bits not decoded
void gameslot::get_rare_items()
{
   rare_items[0] = 0xff;
   rare_items[1] = 0xff;
   // 4 msbits are "illegal" or not defined rares
   for(int i=0;i<4;i++)
      rare_items[2] = bit_change(rare_items[2],i,1);
}


//-----------------------
// this method is used to toggle current espers espers
void gameslot::change_espers()
{
   char kp = ' ';
      int cursor_y = 4, sel = 'A', i, j;

   clrscr();
   while(1)
// while (kp!='q')
   {
      clrscr();
      gotoxy(16,1);
      cprintf("** Changing possesed espers ** Press a key to switch");

      for(j = 0; j<4; j++)
      {
         for(i=0; i<8; i+=2)
         {
            gotoxy(1,cursor_y);
            cprintf("[%c] %12s : %s",
               sel,decodeesp(j*8+i),
               state[bit_detect(espers[j],i)]);

            // stops after 27 espers
            if(j==3 && i>0)
               break;

            gotoxy(30,cursor_y);
            cprintf("[%c] %12s : %s",
               sel+1,decodeesp(j*8+i+1),
               state[bit_detect(espers[j],i+1)]);

            sel+=2;
            cursor_y++;
         }
      }

      sel='1';

      // those 5 "illegal" espers...
      gotoxy(30,cursor_y);
      cprintf("[%c] %12s : %s",
         sel,"???",
         state[bit_detect(espers[3],3)]);
      sel++;
      cursor_y++;

      for(i=0; i<4; i+=2)
      {
         gotoxy(1,cursor_y);
         cprintf("[%c] %12s : %s",
            sel,"???",
            state[bit_detect(espers[3],i+4)]);

         gotoxy(30,cursor_y);
         cprintf("[%c] %12s : %s",
            sel+1,"???",
            state[bit_detect(espers[3],i+1+4)]);

         sel+=2;
         cursor_y++;
      }

      gotoxy(1,cursor_y+1);
      cprintf("[space] All on",sel+1);
      gotoxy(30,cursor_y+1);
      cprintf("[z] All off",sel+2);

      gotoxy(30,cursor_y+3);
      cprintf("[q] Return to sub menu");
      cursor_y  = 4;    // reset cursor origin
      sel       = 'A';     // reset menu letter
      kp = getch();


      if( kp>='A' && kp<='A'+27 )
      {
         espers[(kp-'A')/8] = bit_toggle(espers[(kp-'A')/8],(kp-'A')%8);
      }
      else if( kp>='1' && kp<='5' )
      {
         espers[3] = bit_toggle(espers[3],(kp-'1'+3)%8);
      }
      else  if (kp == ' ')
      {
         for(i=0;i<3;i++)
            espers[i] = 0xFF;
         for(i=0;i<3;i++)
            espers[3] = bit_change(espers[3],i,1);
      }
      else  if (kp == 'z')
      {
         for(i=0;i<3;i++)
            espers[i] = 0x00;
         for(i=0;i<3;i++)
            espers[3] = bit_change(espers[3],i,0);
      }
      else  if (kp == 'q')
         break;
      else
      {
         gotoxy(1,24);
         cprintf("\n\r** Invalid entry! Press a key **");
         getch();
      }
   }
}





//-----------------------
//-----------------------
// this class consist of describing and modifiing ALL that characterise
// a chosen player.
// Inputs: slot data
class player
{
private:


public:
   unsigned char playerdata[car_info_lenght];

   unsigned char profile1;
   unsigned char profile2;

   unsigned char name[name_lenght];
   unsigned char asciiname[name_lenght+1];
   unsigned char level;

   unsigned char got_hp_lsb;   // that's the player current HP
   unsigned char got_hp_msb;
   unsigned char max_hp_lsb;   // that's the player maximum HP
   unsigned char max_hp_msb;
   unsigned char got_mp_lsb;   // samething as above, but for MPs
   unsigned char got_mp_msb;
   unsigned char max_mp_lsb;
   unsigned char max_mp_msb;
   unsigned char got_exp_lsb;  // samething as above, but for Exp points
   unsigned char got_exp_midsb;
   unsigned char got_exp_msb;  // I'll take a chance and hope it's the MSB

   unsigned char status_a;
   unsigned char status_b;     //  still some bits not decoded

   unsigned char battle_com1;
   unsigned char battle_com2;
   unsigned char battle_com3;  // each of the four battle commands
   unsigned char battle_com4;

   unsigned char vigor;
   unsigned char speed;
   unsigned char stamina;
   unsigned char magicpwr;
   unsigned char esper;

   unsigned char sword;
   unsigned char shield;
   unsigned char helmet;
   unsigned char armor;
   unsigned char relic1;
   unsigned char relic2;

   // rank 13 thru 16 don't have magic
   unsigned char magic_pct[max_magic];

   int rank;  // 1 to 16

   player();
   player(const int ordr) {  player(); rank = ordr;  }
   player(const int, const unsigned char*);
   player(const player&);
   void loadspecs();
   int  operator ==(const player&);
   void operator =(const player&);

   int  rename();
   void change_raster(gameslot&);
   void change_act();
   void change_car();
   void change_lev();
   void change_esp();
   void change_hp();
   void change_mp();
   void change_exp();
   void change_wpn(unsigned char);
   void change_menu(unsigned char);
   void change_byte(unsigned char);
   void change_status_a();
   void change_status_b();
   void change_magic();
   void writespecs();
   void showfullspecs(gameslot &gs);
};
// end of player class

//-----------------------
// creates a player, for personnal customizing
player::player()
{
   rank=17;
   for (int u = 0; u<name_lenght; u++)
   playerdata[u+2] = ''; // need the up convert function

   playerdata[0]  = 0;
   playerdata[1]  = 0;

   playerdata[8]  = 1;

   playerdata[9]  = 30;
   playerdata[10] = 0;
   playerdata[11] = 30;
   playerdata[12] = 0;

   playerdata[13] = 30;
   playerdata[14] = 0;
   playerdata[15] = 30;
   playerdata[16] = 0;

   playerdata[17] = 0x0;
   playerdata[18] = 0x0;
   playerdata[19] = 0x0;

   playerdata[20] = 0;
   playerdata[21] = 0;

   playerdata[22] = 0;
   playerdata[23] = 0xFF;
   playerdata[24] = 0xFF;
   playerdata[25] = 0x01;

   playerdata[26] = 0x1E;
   playerdata[27] = 0x1E;
   playerdata[28] = 0x1E;
   playerdata[29] = 0x1E;
   playerdata[30] = 0xFF;

   playerdata[31] = 0x00;
   playerdata[32] = 0xFF;
   playerdata[33] = 0xFF;
   playerdata[34] = 0xFF;
   playerdata[35] = 0xFF;
   playerdata[36] = 0xFF;

   for (int j = 0; j<max_magic ;j++)
   {  magic_pct[j] = 0;}

   loadspecs();
}



//-----------------------
// this constructor makes a player from a given slot and player index
player::player(const int order, const unsigned char * slotd)
{
   for (int i = 0; i<car_info_lenght; i++)
   {
      playerdata[i] = slotd[(order-1)*car_info_lenght+i];
   }
// cprintf(" %x ",slotd[2518]);getch(); // the last bug
   loadspecs();
   rank=order;

   for (int j = 0; j<max_magic ;j++)
   {  magic_pct[j] = slotd[(order-1)*max_magic+1134+j];}

}

//-----------------------
// this method is used to refresh data into THE buffer of the player
// absolutely needed for hacking specifics data, use repetably,
// after each modification
void player::loadspecs()
{
   profile1 = playerdata[0];
   profile2 = playerdata[1];

   for (int i =0; i<name_lenght; i++)
      name[i] = playerdata[2+i];

   asciiname[name_lenght] = '\0';
   downconvert(name,name_lenght,asciiname);

   level= playerdata[8];

   got_hp_lsb = playerdata[9];
   got_hp_msb = playerdata[10];
   max_hp_lsb = playerdata[11];
   max_hp_msb = playerdata[12];

   got_mp_lsb = playerdata[13];
   got_mp_msb = playerdata[14];
   max_mp_lsb = playerdata[15];
   max_mp_msb = playerdata[16];

   got_exp_lsb   = playerdata[17];
   got_exp_midsb = playerdata[18];
   got_exp_msb   = playerdata[19];

   status_a = playerdata[20];
   status_b = playerdata[21];

   battle_com1 = playerdata[22];
   battle_com2 = playerdata[23];
   battle_com3 = playerdata[24];
   battle_com4 = playerdata[25];

   vigor   = playerdata[26];
   speed   = playerdata[27];
   stamina = playerdata[28];
   magicpwr= playerdata[29];
   esper  = playerdata[30];

   sword  = playerdata[31];
   shield = playerdata[32];
   helmet = playerdata[33];
   armor  = playerdata[34];
   relic1 = playerdata[35];
   relic2 = playerdata[36];
}

//-----------------------
// this operator is used to copy a player's full specs in another
void player::operator =(const player& p)
{
   for (int i = 0; i<car_info_lenght; i++)
   {
      playerdata[i] = p.playerdata[i];
   }
   loadspecs();
   rank=p.rank;

   if ( (rank-1) < 14 )
   {
      for (int j = 0; j<max_magic ;j++)
      {  magic_pct[j] = p.magic_pct[j];}
   }
}

//-----------------------
// this constructor is used to copy one player onto another
player::player(const player& p_)
{
   if (playerdata==0) exit(1);
   for (int i = 0; i<car_info_lenght; i++)
   {
      playerdata[i] = p_.playerdata[i];
   }
   loadspecs();
   rank=p_.rank;

   if ( (rank-1) < 14 )
   {
      for (int j = 0; j<max_magic ;j++)
      {  magic_pct[j] = p_.magic_pct[j];}
   }
}


//-----------------------
// this operator compare 2 players
int player::operator ==(const player& p)
{
   for (int i = 0; i<car_info_lenght; i++)
   {
      if (playerdata[i] != p.playerdata[i]) return 0;
   }


/* for (int j = 0; j<max_magic ;j++)
   {
      if (magic_pct[j] != p.magic_pct[j]) return 0;
   }
*/ return 1;

}

//-----------------------
// this method takes care of row, mapman, order, team number
//   bit 0 is LSB
//   bit0: team nb lower bit
//   bit1: team nb higher bit
//   bit2: team nb bit3????
//   bit3: order nb lower bit
//   bit4: order nb higher bit
//   bit5: rank 1=back 0=front
//   bit6: presence in raster on load game(buggy); 1=is present; 0=is absent
//   bit7: mapman state: 1=is mapman,0=not mapman; if order not 1st, buggy
//
// note: since mapman state bit is buggy if not handled properly, it is handled
// with this method
void player::change_raster(gameslot &gs)      // repere
{
   unsigned char bak = gs.raster_info[(rank-1)];
   unsigned int temp_int = 0;
   char kp = ' ';
   char t_ = ' ';

   while(t_ != 'y'&&t_ != 'n')
   {
      clrscr();
      while (kp!='q')
      {
         clrscr();
         gotoxy(22,1);
         cprintf("** Player's role in raster **");
         gotoxy(1,4);
         cprintf("[a] is in team nb : %d",int(gs.raster_info[(rank-1)] & 0x03));
         gotoxy(30,4);
         cprintf("[b] bit 3 ???: %s",state[bit_detect(gs.raster_info[(rank-1)],2)]);
         gotoxy(1,5);
         cprintf("[c] rank          : %d",(int( (gs.raster_info[(rank-1)] >> 3) & 0x03) +1));
         gotoxy(30,5);
         cprintf("[d] row      : %s",row[bit_detect(gs.raster_info[(rank-1)],5)]);
         gotoxy(1,7);
         cprintf("[e] btl. presence : %s",state[bit_detect(gs.raster_info[(rank-1)],6)]);
         gotoxy(30,7);
         // debug: removed, ff3 handle it not well
/*
         cprintf("[f] selectable on airship  : %s",
            state[bit_detect(gs.active_members[(rank-1)/8],(rank-1)%8)]);
*/
/* gotoxy(30,8);
   cprintf("[] is mapman: %s",state[bit_detect(gs.raster_info[(rank-1)],7)]);
*/
         gotoxy(30,10);
         cprintf("[q] Return to sub menu");
         kp = getch();
         switch(kp)
         {
            case 'a':
            {
               do
               {
                  gotoxy(1,20);
                  cprintf("- Changing team number - Enter new entry (1 to 3, 0 not in a team): ");
                  cin >> temp_int;

                  if (temp_int>3)
                  {
                     gotoxy(1,22);
                     clreol();
                     cprintf("** Out of range! Press a key **");
                     getch();
                  }
               }
               while (temp_int>3);
               gs.raster_info[(rank-1)]&=0xfc;
               gs.raster_info[(rank-1)]|=temp_int;
               break;
            }
            case 'b':
            {  gs.raster_info[(rank-1)] = bit_toggle(gs.raster_info[(rank-1)],2);break;}
            case 'c':
            {
               do
               {
                  gotoxy(1,20);
                  cprintf("- Changing position in team - Enter new entry (1 to 4): ");
                  cin >> temp_int;

                  if (temp_int>4||temp_int<1)
                  {
                     gotoxy(1,22);
                     clreol();
                     cprintf("** Out of range! Press a key **");
                     gotoxy(1,22);
                     getch();
                     clreol();
                  }
               }
               while (temp_int>4||temp_int<1);

               if (temp_int==1)
                  gs.raster_info[(rank-1)]=bit_change(gs.raster_info[(rank-1)],7,1);
               else
                  gs.raster_info[(rank-1)]=bit_change(gs.raster_info[(rank-1)],7,0);

               gs.raster_info[(rank-1)]&=0xe7;   //mask
               gs.raster_info[(rank-1)]|=((unsigned char)(temp_int-1)<<3);
               break;
            }
            case 'd':
            {  gs.raster_info[(rank-1)] = bit_toggle(gs.raster_info[(rank-1)],5);break;}
            case 'e':
            {  gs.raster_info[(rank-1)] = bit_toggle(gs.raster_info[(rank-1)],6);break;}

            // debug: removed, see above
/*          case 'f':
            {
               gs.active_members[(rank-1)/8] = bit_toggle(gs.active_members[(rank-1)/8],(rank-1)%8);
               break;
            }
*/
            case 'q': break;
            default :
            {
               gotoxy(1,24);
               cprintf("\n\r** Invalid entry! Press a key **");
               getch();
               break;
            }
         }
      }
      gotoxy(1,24);
//    cprintf("\n\r- Quitting to sub menu - Keep modification [y]/[n], cancel [any key] ?");
//    t_=getche();
      t_ = 'y';
      clrscr();
   }
   if (t_=='n') gs.raster_info[(rank-1)] = bak;
}



//-----------------------
// this method is used to edit the actor used
void player::change_act()
{
   unsigned char tempbyte=0;
   int count =0;
   int thingcn=0;
   char keyp = ' ';
   clrscr();
   cprintf("** List of actors **\n\r\n\r\n\r");
   while((count<=63)&&(keyp!='y'))
   {
      {
         for(int j = 0; j<4; j++)
         {
            gotoxy(j*19+1,wherey());
            cprintf("[%02d] %s",int(count),decodeact(count));
            count++;
         }
         cprintf("\n\r");
         if (count>=255) break;
      }
      thingcn++;
   }
   int entry;
   cprintf("\n\r- Changing actor, current: %s - Enter new entry (0 to 255): ",decodeact(profile1));
   cin >> entry;
   tempbyte = entry & 0xFF;
   profile1 = tempbyte;
}



//-----------------------
// this method is used to edit the sprite used
void player::change_car()
{
   unsigned char tempbyte=0;
   int count =0;
   int thingcn=0;
   char keyp = ' ';
   clrscr();
   cprintf("** List of sprites **\n\r\n\r\n\r");
   while((count<=52)&&(keyp!='y'))
   {
      {
         for(int j = 0; j<3; j++)
         {
            gotoxy(j*21+1,wherey());
            cprintf("[%d] %s",int(count),decodecar(count));
            count++;
         }
         cprintf("\n\r");
         if (count>=255)
            break;
      }
      thingcn++;
   }
   int entry;
   cprintf("\n\r- Changing sprite, current: %s - Enter new entry (0 to 255): ",decodecar(profile2));
   cin >> entry;
   tempbyte = entry & 0xFF;
   profile2 = tempbyte;
}


//-----------------------
// this method is used to edit the esper equiped
void player::change_esp()
{
   unsigned char tempbyte=0;
   const int illegal_esp = 27;
   int count =0, j;
   int thingcn=0;
   char keyp = ' ';

   clrscr();
   cprintf("** List of espers **\n\r");
   cprintf("\n\rOfficial espers:\n\r");
   while((count<=46)&&(keyp!='y'))
   {
      for(j = 0; j<3; j++)
      {
         gotoxy(j*21+1,wherey());
         cprintf("[%d] %s",int(count),decodeesp(count));
         count++;
         if (count == illegal_esp) break;
      }
      if (count == illegal_esp)
         cprintf("\n\r\"New\" espers:");
      cprintf("\n\r");
      if (count>=255) break;
      thingcn++;
   }
   cprintf("\n\r[255] No esper");

   int entry;
   cprintf("\n\r- Changing esper, current: %s - Enter new entry (0 to 255): ",decodeesp(esper));
   cin >> entry;
   tempbyte = entry & 0xFF;
   esper = tempbyte;
}



//-----------------------
// this method is used to edit the name of the player
int player::rename(void)
{
   unsigned char newname[30];
   int y = wherey();
   gotoxy(1,y);
   cprintf("- Changing name - Enter new entry (max 6 car.): ");
   clreol();
   cscanf("%[^\n^\r]",newname);  // reads until eol
   getch(); // catch the \n rejected from cscanf
   if ( int(strlen((char *)newname))>name_lenght)
   {
      cprintf("** String too long! Press a key **");
      clreol();
      getch();
      return 1;
   }


   // clear out old car. if new name is shorter
   int spaces = name_lenght-int(strlen((char *)newname));
   if (spaces>0)
   {  for (int i=name_lenght-spaces;i<name_lenght;i++)
      newname[i] = ' ';
   }

   // down with strcpy
   for (int j =0 ;j<name_lenght;j++)
      asciiname[j] = newname[j];

   upconvert(asciiname,name_lenght,newname);  // format new name to get
   downconvert(newname,name_lenght,asciiname);// rid of uncomp. char.

   return 0;
}




//-----------------------
// This method changes a character's level
void player::change_lev()
{
   unsigned int tempbyte=1;
   int y = wherey();
   gotoxy(1,y);
   cprintf("- Changing level - Enter new entry (1 to 99): ");
   clreol();
   cin >> tempbyte;
   if((tempbyte>=100) || (tempbyte<=0))
   {
      cprintf("** Out of range! Press a key **");
      clreol();
      getch();
   }
   else  level=tempbyte&0xff;
}


//-----------------------
// This method changes a character's maximum HP
void player::change_hp()
{
   unsigned int tempuint=1;
   int y = wherey();
   gotoxy(1,y);
   cprintf("- Changing HP - Enter new entry (1 to 9999): ");
   clreol();
   cin >> tempuint;
   if((tempuint>=10000) || (tempuint<=0))
   {
      cprintf("** Out of range! Press a key **");
      clreol();
      getch();
   }
   else
   {
         got_hp_lsb = tempuint &0xFF;
      max_hp_lsb = got_hp_lsb;

      got_hp_msb = tempuint >> 8;
      max_hp_msb = got_hp_msb;
   }
}


//-----------------------
// This method changes a character's maximum MP
void player::change_mp()
{
   unsigned int tempuint=1;
   int y = wherey();
   gotoxy(1,y);
   cprintf("- Changing MP - Enter new entry (0 to 999): ");
   clreol();
   cin >> tempuint;
   if(tempuint>=1000)
   {
      cprintf("** Out of range! Press a key **");
      clreol();
      getch();
   }
   else
   {
         got_mp_lsb = tempuint &0xFF;
      max_mp_lsb = got_mp_lsb;

      got_mp_msb = tempuint >> 8;
      max_mp_msb = got_mp_msb;
   }
}


//-----------------------
// This method changes a character's experience points
void player::change_exp()
{
   unsigned long tempulong = 0;
   int y = wherey();
   gotoxy(1,y);
   cprintf("- Changing EXP - Enter new entry (0 to 9,999,999): ");
   clreol();
   cin >> tempulong;
   if(tempulong>9999999lu)
   {
      cprintf("** Out of range! Press a key **");
      clreol();
      getch();
   }

   else
   {
      got_exp_lsb   = (unsigned char)(tempulong) & 0xFF;
      got_exp_midsb = (unsigned char)(tempulong >> 8) &0xFF;
      got_exp_msb   = (unsigned char)(tempulong >> 16)&0xFF;
   }
}


//-----------------------
// This method changes 1 of 6 equipement slot
void player::change_wpn(unsigned char pl_eq)
{
   unsigned char tempbyte=0;
   int count =0;
   int thingcn=0;
   char keyp = ' ';

   if (pl_eq==EQ_SWRD) tempbyte = sword;
   else  if (pl_eq==EQ_SHLD) tempbyte = shield;
   else  if (pl_eq==EQ_HELM) tempbyte = helmet;
   else  if (pl_eq==EQ_ARMR) tempbyte = armor;
   else  if (pl_eq==EQ_REL1) tempbyte = relic1;
   else tempbyte = relic2;


   if (pl_eq>5) pl_eq = 0;
   clrscr();
   cprintf("** List of items **\n\r\n\r");
   cprintf("Skip list? [y]/[n]: ");
   keyp = getche();
   cprintf("\n\r");
   while((count<=255)&&(keyp!='y'))
   {
      cprintf("%s\n\r",&things_type[thingcn][0]);
      while((int(count)<=wpnoffset[thingcn])&&(thingcn<=19))
      {
         for(int j = 0; j<3; j++)
         {
            gotoxy(j*21+1,wherey());
            cprintf("[%d] %s",int(count),decodeitem(count));
            count++;
            if (count>wpnoffset[thingcn]) break;
         }
         cprintf("\n\r");
      if (count>=255) break;
      }
      thingcn++;
      getch();
   }
   int entry;
   cprintf("\n\r- Changing %s, current: %s - Enter new entry (0 to 255): ",&equip_type[pl_eq][0],decodeitem(tempbyte));
   cin >> entry;
   tempbyte = entry & 0xFF;
   if (pl_eq==EQ_SWRD) sword = tempbyte;
   else  if (pl_eq==EQ_SHLD) shield = tempbyte;
   else  if (pl_eq==EQ_HELM) helmet = tempbyte;
   else  if (pl_eq==EQ_ARMR) armor = tempbyte;
   else  if (pl_eq==EQ_REL1) relic1 = tempbyte;
   else relic2 = tempbyte;
}

//-----------------------
// This method changes one of the 4 battle command
void player::change_menu(unsigned char menu)
{
   unsigned char tempbyte=0;

   if (menu==BTL_MN1)
      tempbyte = battle_com1;
   else  if (menu==BTL_MN2)
      tempbyte = battle_com2;
   else  if (menu==BTL_MN3)
      tempbyte = battle_com3;
   else
      tempbyte = battle_com4;

   int count =0;

   if (menu>BTL_MN4) menu = BTL_MN1;
   clrscr();
   cprintf("** List of commands **\n\r\n\r\n\r");
   while(count<31)
   {
      for(int j = 0; j<3; j++)
      {
         gotoxy(j*21+1,wherey());
         cprintf("[%d] %s",int(count),decodebtl(count));
         count++;
         if (count>=30) break;
      }
      cprintf("\n\r");
   }
   int entry;
   cprintf("\n\r- Changing battle slot #%s, current: %s - Enter new entry (0 to 30): ",btl_slt[menu],decodebtl(tempbyte));
   cin >> entry;
   tempbyte = entry & 0xFF;

   if (menu==BTL_MN1)
      battle_com1 = tempbyte;
   else  if (menu==BTL_MN2)
      battle_com2 = tempbyte;
   else  if (menu==BTL_MN3)
      battle_com3 = tempbyte;
   else
      battle_com4 = tempbyte;
}

//-----------------------
// This method changes vigor, speed, stamina, intelligence, profile or esper
void player::change_byte(unsigned char a_byte)
{
   unsigned char tempbyte=0;
   if (a_byte>8) a_byte = 6;
   int y = wherey();
   unsigned int tempint=0;
   gotoxy(1,y);
   cprintf("\n\r- Changing %s\'s value - Enter new entry (0 to 255): ",&byte_data[a_byte][0]);
   clreol();
   cin >> tempint;
   tempbyte = tempint & 0xFF;
   if (a_byte==STAT_A) status_a = tempbyte;
   else if (a_byte==STAT_B) status_b = tempbyte;
   else if (a_byte==VIGOR) vigor = tempbyte;
   else if (a_byte==SPEED) speed = tempbyte;
   else if (a_byte==STAMINA) stamina = tempbyte;
   else  if (a_byte==MAGPOW) magicpwr = tempbyte;
   else  if (a_byte==PROF1) profile1 = tempbyte;
   else  if (a_byte==PROF2) profile2 = tempbyte;
   else esper = tempbyte;
}


//-----------------------
// This metod changes the status (part 1 of 2)
void player::change_status_a()
{
   unsigned char bak = status_a;
   char kp = ' ';

   clrscr();
   while (kp!='q')
   {
      clrscr();
      gotoxy(22,1);
      cprintf("** Player's status ** Press a key to switch");
      gotoxy(1,4);
      cprintf("[a] Blindness: %s",&state[bit_detect(status_a,0)][0]);
      gotoxy(30,4);
      cprintf("[b] Zombie   : %s",&state[bit_detect(status_a,1)][0]);
      gotoxy(1,6);
      cprintf("[c] Poison   : %s",&state[bit_detect(status_a,2)][0]);
      gotoxy(30,6);
      cprintf("[d] MagiTek  : %s",&state[bit_detect(status_a,3)][0]);
      gotoxy(1,8);
      cprintf("[e] Invizible: %s",&state[bit_detect(status_a,4)][0]);
      gotoxy(30,8);
      cprintf("[f] Imp      : %s",&state[bit_detect(status_a,5)][0]);
      gotoxy(1,10);
      cprintf("[g] Stone    : %s",&state[bit_detect(status_a,6)][0]);
      gotoxy(30,10);
      cprintf("[h] Death    : %s",&state[bit_detect(status_a,7)][0]);

      gotoxy(1,13);
      cprintf("[i] All on");
      gotoxy(30,13);
      cprintf("[j] All off");
      gotoxy(1,15);
      cprintf("[k] Special");

      gotoxy(30,15);
      cprintf("[q] Return to sub menu");
      kp = getch();
      switch(kp)
      {
         case 'a':
         {  status_a = bit_toggle(status_a,0);break;}
         case 'b':
         {  status_a = bit_toggle(status_a,1);break;}
         case 'c':
         {  status_a = bit_toggle(status_a,2);break;}
         case 'd':
         {  status_a = bit_toggle(status_a,3);break;}
         case 'e':
         {  status_a = bit_toggle(status_a,4);break;}
         case 'f':
         {  status_a = bit_toggle(status_a,5);break;}
         case 'g':
         {  status_a = bit_toggle(status_a,6);break;}
         case 'h':
         {  status_a = bit_toggle(status_a,7);break;}
         case 'i':
         {  status_a = 0xFF;break;}
         case 'j':
         {  status_a = 0x00;break;}
         case 'k':
         {  status_a = 0x53;break;}
         case 'q': break;
         default :
         {
            gotoxy(1,24);
            cprintf("\n\r** Invalid entry! Press a key **");
            getch();
            break;
         }
      }
   }
}


//-----------------------
// This method changes the status (part 2 of 2)
void player::change_status_b()
{
   unsigned char bak = status_b;
   char kp = ' ';

   clrscr();
   while (kp!='q')
   {
      clrscr();
      gotoxy(22,1);
      cprintf("** Player's status ** Press a key to switch");
      gotoxy(1,4);
      cprintf("[a] ?        : %s",&state[bit_detect(status_b,0)][0]);
      gotoxy(30,4);
      cprintf("[b] ?        : %s",&state[bit_detect(status_b,1)][0]);
      gotoxy(1,6);
      cprintf("[c] ?        : %s",&state[bit_detect(status_b,2)][0]);
      gotoxy(30,6);
      cprintf("[d] ?        : %s",&state[bit_detect(status_b,3)][0]);
      gotoxy(1,8);
      cprintf("[e] ?        : %s",&state[bit_detect(status_b,4)][0]);
      gotoxy(30,8);
      cprintf("[f] ?        : %s",&state[bit_detect(status_b,5)][0]);
      gotoxy(1,10);
      cprintf("[g] ?        : %s",&state[bit_detect(status_b,6)][0]);
      gotoxy(30,10);
      cprintf("[h] Float    : %s",&state[bit_detect(status_b,7)][0]);

      gotoxy(1,13);
      cprintf("[i] All on");
      gotoxy(30,13);
      cprintf("[j] All off");
      gotoxy(1,15);
      cprintf("[k] Special");

      gotoxy(30,15);
      cprintf("[q] Return to sub menu");
      kp = getch();
      switch(kp)
      {
         case 'a':
         {  status_b = bit_toggle(status_b,0);break;}
         case 'b':
         {  status_b = bit_toggle(status_b,1);break;}
         case 'c':
         {  status_b = bit_toggle(status_b,2);break;}
         case 'd':
         {  status_b = bit_toggle(status_b,3);break;}
         case 'e':
         {  status_b = bit_toggle(status_b,4);break;}
         case 'f':
         {  status_b = bit_toggle(status_b,5);break;}
         case 'g':
         {  status_b = bit_toggle(status_b,6);break;}
         case 'h':
         {  status_b = bit_toggle(status_b,7);break;}
         case 'i':
         {  status_b = 0xFF;break;}
         case 'j':
         {  status_b = 0x00;break;}
         case 'k':
         {  status_b = 0x53;break;}
         case 'q': break;
         default :
         {
            gotoxy(1,24);
            cprintf("\n\r** Invalid entry! Press a key **");
            getch();
            break;
         }
      }
   }
}


//-----------------------
// This method changes learning rate of spell(s)
// note: this method must not be used for players 13 through 16, they do not have
// their own magic
void player::change_magic()
{
   unsigned char tempbyte1=0;
   unsigned char tempbyte2=0;
   int count =0;
   int mgccnt=0;
   char keyp = ' ';
   char entry[80];
   while(1)
   {
      entry[0]='0';

      clrscr();
      cprintf("** List of magic commands **\n\r");
      while(mgccnt<3)
      {
         cprintf("%s\n\r",&magic_type[mgccnt][0]);
         while( (count<=magicoffset[mgccnt])&&(mgccnt<3) )
         {
            for(int j = 0; j<3; j++)
            {
               gotoxy(j*21+1,wherey());
               cprintf("[%d] %s",int(count),decodemagic(count));
               gotoxy(j*21+13,wherey());
               cprintf(": ");
               if (magic_pct[count]==255)
                  cprintf("100");
               else
                  cprintf("%d",int(magic_pct[count]));
               count++;
               if (count>(magicoffset[mgccnt])) break;
            }
            cprintf("\n\r");
         if (count>=max_magic) break;
         }
         mgccnt++;
      }
      mgccnt = 0;
      count  = 0;

      cprintf("[space]  : max-out\n\r");

      cprintf("- Choose a spell - Entry (0 to 53), [q] to quit: ");

      int i = 0;
      do
      {
         keyp = getche();
         if( keyp != '\b' )
         {
            entry[i] = keyp;
            i++;
         }
         else if (i>0)
         {
            i--;
            clreol();
         }
         if (entry[0]==' ')
         {
            for (int k = 0;k <max_magic ; k++)
            {  magic_pct[k] = 255; }
            break;
         }
      }
      while( keyp !='\r' && keyp !='\n' && keyp != 'q' && keyp != K_ESCAPE && keyp<80);
      if (keyp == 'q') return;

      tempbyte1 = atoi(&entry[0]);

      if (entry[0]!=' ')
      {
         tempbyte1 = tempbyte1 & 0xFF;
         gotoxy(1,wherey());
         cprintf("- Changing learn rate of %s - Enter new entry (0 to 100): ",decodemagic(tempbyte1));
         cin >> entry;
         tempbyte2 = atoi(entry);
         tempbyte2 = tempbyte2 & 0xFF;
         if (tempbyte2<100)
            magic_pct[tempbyte1] = tempbyte2;
         else if (tempbyte2==100)
            magic_pct[tempbyte1] = 255;
         else
            magic_pct[tempbyte1] = 0;
      }
   }
}


//-----------------------
// use when finished hacking
// this method updates all of the player's data onto THE buffer
void player::writespecs()
{
   playerdata[0] = profile1;
   playerdata[1] = profile2;

   unsigned char tempname[name_lenght];
   upconvert(asciiname,name_lenght,tempname);

   for (int i =0; i<name_lenght; i++)  playerdata[2+i] = tempname[i];

   playerdata[8] = level;

   playerdata[9] = got_hp_lsb;
   playerdata[10] = got_hp_msb;
   playerdata[11] = max_hp_lsb;
   playerdata[12] = max_hp_msb;

   playerdata[13] = got_mp_lsb;
   playerdata[14] = got_mp_msb;
   playerdata[15] = max_mp_lsb;
   playerdata[16] = max_mp_msb;

   playerdata[17] = got_exp_lsb;
   playerdata[18] = got_exp_midsb;
   playerdata[19] = got_exp_msb;

   playerdata[20] = status_a;
   playerdata[21] = status_b;

   playerdata[22] = battle_com1;
   playerdata[23] = battle_com2;
   playerdata[24] = battle_com3;
   playerdata[25] = battle_com4;

   playerdata[26] = vigor;
   playerdata[27] = speed;
   playerdata[28] = stamina;
   playerdata[29] = magicpwr;
   playerdata[30] = esper;

   playerdata[31] = sword;
   playerdata[32] = shield;
   playerdata[33] = helmet;
   playerdata[34] = armor;
   playerdata[35] = relic1;
   playerdata[36] = relic2;
}


//-----------------------
// this method shows everything that relates to a player
// sl only used to show raster info, because the data involved is contained somewhere
// in the game slot, it is not specific to the player object
void player::showfullspecs(gameslot &sl)
{
   clrscr();
   gotoxy(15,1);
   cprintf("Full specs of character No %d (+/- to change)\n\r\n\r",rank);

   cprintf("[a]Actor : %s",decodeact(profile1));
   gotoxy(36,wherey());
   cprintf("[b]Sprite: %s\n\r",decodecar(profile2));

   cprintf("[c]Name  : ");

   for (int j=0; j<name_lenght; j++)
      cprintf("%c",asciiname[j]);
   gotoxy(36,wherey());
   if(rank<17)
   {
      if(int(sl.raster_info[(rank-1)] & 0x03)!=0)
         cprintf("[R]Raster: team #%d rank #%d\n\r\n\r",int(sl.raster_info[(rank-1)] & 0x03),(int( (sl.raster_info[(rank-1)] >> 3) & 0x03) +1));
      else
         cprintf("[R]Raster \n\r\n\r");
   }
   else
      cprintf("\n\r\n\r");

   cprintf("[d]Level: %d",int(level));
   gotoxy(36,wherey());

   unsigned long ghp = got_hp_lsb + (got_hp_msb << 8);
   unsigned long mhp = max_hp_lsb + (max_hp_msb << 8);
   cprintf("[e]HP: %U/%U\n\r",ghp,mhp);

   unsigned long exp = (got_exp_lsb + ((unsigned long)got_exp_midsb << 8) + ((unsigned long)got_exp_msb << 16));
   cprintf("[f]Exp. points: %U",exp);
   gotoxy(36,wherey());

   unsigned long gmp = got_mp_lsb + (got_mp_msb << 8);
   unsigned long mmp = max_mp_lsb + (max_mp_msb << 8);
   cprintf("[g]MP: %U/%U\n\r\n\r",gmp,mmp);

   cprintf("[h]Status part 1: %d",int(status_a));
   gotoxy(36,wherey());
   cprintf("[i]Status part 2: %d\n\r",int(status_b));

   cprintf("\n\r[j]Battle command#1: ");
   cprintf("%s",decodebtl(battle_com1));
   gotoxy(36,wherey());

   cprintf("[k]Battle command#2: ");
   cprintf("%s\n\r",decodebtl(battle_com2));

   cprintf("[l]Battle command#3: ");
   cprintf("%s",decodebtl(battle_com3));
   gotoxy(36,wherey());

   cprintf("[m]Battle command#4: ");
   cprintf("%s\n\r",decodebtl(battle_com4));

   cprintf("\n\r[n]Vigor  : %d",int(vigor));
   gotoxy(36,wherey());
   cprintf("[o]Speed       : %d\n\r",int(speed));

   cprintf("[p]Stamina: %d",int(stamina));
   gotoxy(36,wherey());
   cprintf("[r]Magic power : %d\n\r",int(magicpwr));

   cprintf("[z]Esper  : %s",decodeesp(esper));
   gotoxy(36,wherey());

   if (rank<=nb_mgc_users)
      cprintf("[y]Magic spells");
   cprintf("\n\r\n\r");

   cprintf("[s]Sword  : %s",decodeitem(sword));
   gotoxy(36,wherey());

   cprintf("[t]Shield : %s\n\r",decodeitem(shield));
   cprintf("[u]Helmet : %s",decodeitem(helmet));
   gotoxy(36,wherey());
   cprintf("[v]Armor  : %s\n\r",decodeitem(armor));
   cprintf("[w]Relic#1: %s",decodeitem(relic1));
   gotoxy(36,wherey());
   cprintf("[x]Relic#2: %s\n\r",decodeitem(relic2));
   cprintf("\n\r");

   cprintf("[q]Return to main");
   gotoxy(36,wherey());
   cprintf("[space]Max-out that character!");
   cprintf("\n\r");

   cprintf("[C]Copy character to buffer");
   gotoxy(36,wherey());
   cprintf("[P]Paste copied character");
   cprintf("\n\r");
}




//-----------------------
//-----------------------
//  This class is probably temporary, it stores the rest of the data
//  of the sram file into a buffer
//  the data contained is probably random... but i can't tell for sure
class sramdata
{
private:

public:
   sramdata(){}
   sramdata(ifstream &sr);
   void showsramdata();
   void writesram(ifstream &sr);
   void edit_byte(void);
   long filelenght;
   long xtralenght;
   unsigned char data[1000];
};



//-----------------------
// This constructor reads the "padding" of the SRAM directly from the file
sramdata::sramdata(ifstream& sr)
{
   sr.seekg(0, ios::end);   // last byte of file
   filelenght = sr.tellg(); // that file is 'filelenght' long
   xtralenght = filelenght - 3*slot_lenght;

   if (xtralenght>1000)
   {
      cprintf("File too big! Padding truncated!\n\r");
      getch();
      xtralenght = 1000;
   }

   assert(data);
   if (data==0) exit(1);

   sr.seekg(3*slot_lenght, ios::beg);
   for (int i = 0; i<int(xtralenght); i++)
   {  sr.read(&bytecontent,bytesize);
//    cprintf(" (%d),",int(bytecontent));
      data[i] = bytecontent;
   }
}

// debug: not working/saving yet
void sramdata::writesram(ifstream& sr)
{
   sr.seekg(3*slot_lenght, ios::beg);
   for (int i = 0; i<int(xtralenght); i++)
   {
      bytecontent = data[i];
      sr.putback(bytecontent);
   }
}

void sramdata::edit_byte(void)
{
   int adress, mod;
   cprintf("\n\r** Warning, data that's modified is automaticly updated! **\n\r");
   cprintf(" Do you want to edit a raw hexadecimal data? [y]/[n] ");
   char kp = getche();
   if (kp=='y')
   {
      cprintf("\n\r- Editing raw data - enter adress to edit (0 to %d): ",xtralenght-1);
      cin >> adress;
      cprintf("- Old value: %d - enter new value (0 to 255): ",
         int(data[adress]));

      cin >> mod;
      data[adress] = (unsigned char)mod;
   }
   else
   {
      cprintf("\n\r- Request canceled - press a key");
      getch();
   }
}



//-----------------------
// This method all the bytes
void sramdata::showsramdata()
{
   clrscr();
   delay(500);
   cprintf("Content of the rest of the sram (aka padding):\n\r");
   cprintf("We have %D bytes after the 3 slots\n\r",xtralenght);
   for (int i =0; i<xtralenght;i++)
      cprintf("%d ",int(data[i]));
   // debug: not working/saving yet
// edit_byte();
   getch();
}




void showquickspecs(const player&);
void mainmenu();
void submenu1(gameslot&,player*);
void submenu2(gameslot&);
void submenu3(gameslot&,sramdata&);
void item_menu(gameslot& sl);
template<class T> void swapbytes(T,int);

//-----------------------
//-----------------------
// this function gives a quick look at the player's specs
void showquickspecs(const player& pl_)
{
 //   show info in that order: Position   Name   Level  Max HP  Max MP
   cprintf("   %2d      ",pl_.rank);
   for (int j=0; j<name_lenght; j++)
      cprintf("%c",pl_.asciiname[j]);

   cprintf("   %2d",int(pl_.level));
   long hp = pl_.max_hp_lsb + (pl_.max_hp_msb << 8);
   cprintf("    %4D",hp);
   long mp = pl_.max_mp_lsb + (pl_.max_mp_msb << 8);
   cprintf("    %4D",mp);
   cprintf("\n\r");
}


//-----------------------
// This function bring up quick specs, then show the main menu to edit a player
void submenu1(gameslot& sl)
{
   player *team;
   team = new player [nb_players_menu+1];
   assert(team);

   for (int j = 1 ; j<=nb_players ; j++)
   {
      player tempo(j,sl.slotdata);
      team[j] = tempo;
   }

   for (int k = 17 ; k<=nb_players_menu; k++) team[k].rank = k;

   clrscr();

   // this is the quick menu feature
   cprintf("Position   Name   Level  Max HP  Max MP\n\r");
   for (int i = 1; i<=nb_players; i++)
   {
      showquickspecs(team[i]);
   }

   player buffer;
   int buffer_rank = 17;
   char keypress = ' ';
   int cnt = 1; // user defined in future menu, if single editing
   getch();
   char t_ = ' ';
   while( (t_!='y')&&(t_!='n') )
   {
      clrscr();
      while (keypress!='q')
      {
         team[cnt].showfullspecs(sl);
         cprintf("Type a letter to edit: ");
         keypress = getche();
         delline();
         switch(keypress)
         {
            case 'a':
            {  team[cnt].change_act();break; }

            case 'b':
            {  team[cnt].change_car();break; }

            case 'c':
            {  team[cnt].rename();break;  }

            case 'd':
            {  team[cnt].change_lev();break; }

            case 'e':
            {  team[cnt].change_hp();break;  }

            case 'f':
            {  team[cnt].change_exp();break; }

            case 'g':
            {  team[cnt].change_mp();break;  }

            case 'h':
            {  team[cnt].change_status_a();break;  }

            case 'i':
            {  team[cnt].change_status_b();break;     }

            case 'j':
            {  team[cnt].change_menu(BTL_MN1);break;  }

            case 'k':
            {  team[cnt].change_menu(BTL_MN2);break;  }

            case 'l':
            {  team[cnt].change_menu(BTL_MN3);break;  }

            case 'm':
            {  team[cnt].change_menu(BTL_MN4);break;  }

            case 'n':
            {  team[cnt].change_byte(VIGOR);break; }

            case 'o':
            {  team[cnt].change_byte(SPEED);break; }

            case 'p':
            {  team[cnt].change_byte(STAMINA);break;  }

            case 'r':
            {  team[cnt].change_byte(MAGPOW);break;   }

            case 'R':
            {  team[cnt].change_raster(sl);break;  }

            case 'z':
            {  team[cnt].change_esp();break; }

            case 's':
            {
               team[cnt].change_wpn(EQ_SWRD);
               break;
            }

            case 't':
            {
               team[cnt].change_wpn(EQ_SHLD);
               break;
            }

            case 'u':
            {
               team[cnt].change_wpn(EQ_HELM);
               break;
            }

            case 'v':
            {
               team[cnt].change_wpn(EQ_ARMR);
               break;
            }

            case 'w':
            {
               team[cnt].change_wpn(EQ_REL1);
               break;
            }

            case 'x':
            {
               team[cnt].change_wpn(EQ_REL2);
               break;
            }

            case 'y':
            {
               if (team[cnt].rank<=nb_mgc_users)
               {
                  team[cnt].change_magic();
               }
               else
               {
                  cprintf("\n\r** Invalid entry! Press a key **");
                  getch();
               }
               break;
            }


            case ' ':
            {
               team[cnt].got_hp_lsb = 0x0F;
               team[cnt].got_hp_msb = 0x27;
               team[cnt].max_hp_lsb = 0x0F;
               team[cnt].max_hp_msb = 0x27;

               team[cnt].got_mp_lsb = 0xE7;
               team[cnt].got_mp_msb = 0x03;
               team[cnt].max_mp_lsb = 0xE7;
               team[cnt].max_mp_msb = 0x03;

               team[cnt].got_exp_lsb   = 0x7f;
               team[cnt].got_exp_midsb = 0x96;
               team[cnt].got_exp_msb   = 0x98;

               team[cnt].level = 99;
               break;
            }

            case 'C':
            {
               buffer=team[cnt];
               int y = wherey();
               gotoxy(1,y);
               cprintf("\n\r- character copied to buffer - press a key ");
               clreol();
               getch();
               break;
            }

            case 'P':
            {
               int y = wherey();
               gotoxy(1,y);
               cprintf("\n\r- Curent character to be replaced? - [y]/[n] ");
               char t__;
               t__ = getche();
               clreol();
               buffer_rank = team[cnt].rank;
               if (t__=='y')
               {
                  team[cnt]=buffer;
                  team[cnt].rank = buffer_rank;
               }
               break;
            }

            case 'q': break;
            case '+': break;
            case '=': break;
            case '-': break;

            default :
            {
               cprintf("\n\r** Invalid entry! Press a key **");
               getch();
               break;
            }
         }
         if ((keypress=='+')||(keypress=='=')) cnt++;   // + - cursor to browse
         if (keypress=='-') cnt--;   // between players
         if (cnt>18) cnt = 1;
         if (cnt<1) cnt = 18;

      }
//    cprintf("\n\r- Quitting to main - Keep modification [y]/[n], cancel [any key] ?");
//    t_=getche();
      t_='y';
      clrscr();
   }
   if (t_=='y')
   {
      for (int k=1; k<=nb_players; k++)
      {
         team[k].writespecs();
         sl.save_player(team[k].playerdata,team[k].magic_pct,k);
      }
      cprintf("Refreshing general & player info...");
      // checksum done in there
      sl.save_misc();      // for raster info
   }
   delete [] team; team = 0;
}




//-----------------------
// This function show the second menu, which brings up raw/gold/item/blitz/ect. editors
void submenu2(gameslot& sl)
{
   char kp = ' ';
   char t_ = ' ';
   int  y_curs;

   while ((t_!='y')&&(t_!='n'))
   {
      clrscr();
      while (1)
      {
         clrscr();
         gotoxy(22,1);
         cprintf("** General stuff, abilities, items **\n\r\n\r");
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         // debug: still buggy, ff3 shows only official
         //   getable players in shops, dunno for airship
//       cprintf("[a] Make all characters selectable");
         cprintf("[a] <menu not implemented>");
         gotoxy(36,y_curs);
         cprintf("[b] Number of saves: %d", sl.nb_saves);
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         cprintf("[c] Gold : %D",sl.gold_tot);
         gotoxy(36,y_curs);
         cprintf("[d] Time : %dh%dm%ds",(int)sl.gtime[0],(int)sl.gtime[1],(int)sl.gtime[2]);
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         cprintf("[e] Steps: %D",sl.steps_tot);
         gotoxy(36,y_curs);
         cprintf("[f] Edit item list");
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         cprintf("[g] Edit blitz list");
         gotoxy(36,y_curs);
         cprintf("[h] Edit lores list");
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         cprintf("[i] Get all rages");
         gotoxy(36,y_curs);
         cprintf("[j] Edit sword tech");
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         cprintf("[k] Edit dances list");
         gotoxy(36,y_curs);
         cprintf("[l] Edit esper list");
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         cprintf("[m] Overworld location: X:%D Y:%D",sl.map_xy[0],sl.map_xy[1]);
         gotoxy(36,y_curs);
         cprintf("[n] Airship location: X:%D Y:%D",sl.airship_xy[0],sl.airship_xy[1]);
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         cprintf("[o] Airship is anchored : %s",&ttruth[bit_detect(sl.airship_state,2)][0]);
         gotoxy(36,y_curs);
         cprintf("[p] Airship is visible : %s",&ttruth[bit_detect(sl.airship_state,1)][0]);
         y_curs = wherey()+2;

         gotoxy(1,y_curs);
         cprintf("[q] Quit to main");
         y_curs = wherey()+1;

         gotoxy(1,y_curs);
         kp = getch();

         switch(kp)
         {
            // debug: removed, see above
/*          case 'a':
            {
               sl.active_members[0]=0xFF;
               sl.active_members[1]=0xFF;
               gotoxy(1,23);
               cprintf("- All characters are visible in shop and airship! - Press a key ");
               getch();
               break;
            }
*/
            case 'b':
            {
               unsigned int temp_saves;
               cprintf("- Changing number of saves - Enter new entry (0 to 255): ");
               cin >> temp_saves;

               if (temp_saves>255)
               {
                  gotoxy(1,22);
                  clreol();
                  cprintf("** Out of range! Press a key **");
                  getch();
               }
               else
                  sl.nb_saves = temp_saves;
               break;
            }

            case 'c':
            {
               unsigned long temp_gold = 0lu;
               do
               {
                  clreol();
                  cprintf("- Changing gold - Enter new entry (0 to 9,999,999): ");
                  cin >> temp_gold;

                  if (temp_gold>9999999lu)
                  {
                     gotoxy(1,22);
                     clreol();
                     cprintf("** Out of range! Press a key **");
                     getch();
                  }
               }
               while (temp_gold>9999999lu);
               sl.gold_tot=temp_gold;
               break;
            }

            case 'd':
            {
               int temp_time = 0;
               do
               {
                  clreol();
                  //gotoxy(1,19);
                  cprintf("- Changing time:   hours - Enter new entry (0 to 99): ");
                  cin >> temp_time;

                  if (temp_time>99)
                  {
                     gotoxy(1,22);
                     clreol();
                     cprintf("** Out of range! Press a key **");
                     getch();
                  }
               }
               while (temp_time>99);
               sl.gtime[0]=temp_time;

               do
               {
                  //clreol();
                  //gotoxy(1,20);
                  cprintf("- Changing time: minutes - Enter new entry (0 to 59): ");
                  cin >> temp_time;

                  if (temp_time>59)
                  {
                     gotoxy(1,22);
                     clreol();
                     cprintf("** Out of range! Press a key **");
                     getch();
                  }
               }
               while (temp_time>59);
               sl.gtime[1]=temp_time;

               do
               {
                  //clreol();
                  //gotoxy(1,21);
                  cprintf("- Changing time: seconds - Enter new entry (0 to 59): ");
                  cin >> temp_time;

                  if (temp_time>59)
                  {
                     gotoxy(1,22);
                     clreol();
                     cprintf("** Out of range! Press a key **");
                     getch();
                  }
               }
               while (temp_time>59);
               sl.gtime[2]=temp_time;

               break;
            }

            case 'e':
            {
               unsigned long temp_step = 0lu;
               do
               {
                  clreol();
                  cprintf("- Changing steps - Enter new entry (0 to 9,999,999): ");
                  cin >> temp_step;

                  if (temp_step>9999999lu)
                  {
                     gotoxy(1,22);
                     clreol();
                     cprintf("** Out of range! Press a key **");
                     getch();
                  }
               }
               while (temp_step>9999999lu);
               sl.steps_tot=temp_step;
               break;
            }

            case 'f':
            {  item_menu(sl);break; }

            case 'g':
            {  sl.change_blitz();break;   }

            case 'h':
            {  sl.change_lores();break;   }

            case 'i':
            {
               sl.get_rages();
               gotoxy(1,23);
               cprintf("- Got all rages! - Press a key ");
               getch();
               break;
            }
            case 'j':
            {
               sl.change_swrdtech();
               break;
            }
            case 'k':
            {
               sl.change_dances();
               break;
            }

            case 'l':
            {  sl.change_espers();break;  }

            case 'm':
            {
               unsigned int temp_x, temp_y;
               cprintf("- Changing overworld XY location - Enter new X location (0 to 255): ");
               cin >> temp_x;

               if (temp_x>255)
               {
                  gotoxy(1,22);
                  clreol();
                  cprintf("** Out of range! Press a key **");
                  getch();
               }
               else
                  sl.map_xy[0] = temp_x;

               cprintf("- Changing overworld XY location - Enter new Y location (0 to 255): ");
               cin >> temp_y;

               if (temp_y>255)
               {
                  gotoxy(1,22);
                  clreol();
                  cprintf("** Out of range! Press a key **");
                  getch();
               }
               else
                  sl.map_xy[1] = temp_y;

               break;
            }

            case 'n':
            {
               unsigned int temp_x, temp_y;
               cprintf("- Changing airship XY location - Enter new X location (0 to 255): ");
               cin >> temp_x;

               if (temp_x>255)
               {
                  gotoxy(1,22);
                  clreol();
                  cprintf("** Out of range! Press a key **");
                  getch();
               }
               else
                  sl.airship_xy[0] = temp_x;

               cprintf("- Changing airship XY location - Enter new Y location (0 to 255): ");
               cin >> temp_y;

               if (temp_y>255)
               {
                  gotoxy(1,22);
                  clreol();
                  cprintf("** Out of range! Press a key **");
                  getch();
               }
               else
                  sl.airship_xy[1] = temp_y;

               break;
            }
            case 'o':
            {
               sl.airship_state = bit_toggle(sl.airship_state,2);
               break;
            }
            case 'p':
            {
               sl.airship_state = bit_toggle(sl.airship_state,1);
               break;
            }
            case 'q': break;

            default :
            {
               gotoxy(1,23);
               cprintf("** Invalid entry! Press a key **");
               getch();
               break;
            }
         }
         if (kp=='q') break;
      }
      gotoxy(1,24);
      t_ = 'y';
      clrscr();
   }
   if (t_=='y')
      sl.save_misc();
}



//-----------------------
// This function show the third menu, which brings up advanced setting editors
void submenu3(gameslot& sl,sramdata& xtra)
{
   char kp = ' ';
   char t_ = ' ';
   while ((t_!='y')&&(t_!='n'))
   {
      clrscr();
      while (1)
      {
         clrscr();
         gotoxy(22,1);
         cprintf("** Advanced editing, debuger **\n\r\n\r");

         cprintf("[a] Edit a byte from slot's data");
         gotoxy(36,wherey());
         cprintf("[b] SRAM extra bytes (padding) viewer\n\r");

         cprintf("[q] Quit to main\n\r");

         kp = getch();
         switch(kp)
         {
            case 'a':
            {  sl.showgs();break;   }

            case 'b':
            {  xtra.showsramdata();break; }

            case 'q': break;

            default :
            {
               gotoxy(1,23);
               cprintf("** Invalid entry! Press a key **");
               getch();
               break;
            }
         }
         if (kp=='q') break;
      }
      gotoxy(1,24);
      t_ = 'y';      // old y/n menu deinstalled
      clrscr();
   }
}


//-----------------------
// This function changes a specific item location in the list and its quantity
void item_menu(gameslot& sl)
{
   char kp = ' ';
   {
      clrscr();
      while (kp!='q')
      {
         clrscr();
         gotoxy(22,1);
         cprintf("** Items editor **");
         gotoxy(22,10);
         cprintf("[a] View and change a single item");
         gotoxy(22,12);
         cprintf("[b] Max out current items");
         gotoxy(22,14);
         cprintf("[c] Get all item x99");
         gotoxy(22,16);
         cprintf("[d] Get all rare items");
         gotoxy(22,18);
         cprintf("[q] Quit to sub menu");

         kp = getch();
         switch(kp)
         {
            case 'a':
            {  sl.view_itm_lst();break;   }

            case 'b':
            {  sl.max_out_items();break;  }

            case 'c':
            {  sl.get_items();break;   }

            case 'd':
            {
               sl.get_rare_items();
               gotoxy(1,23);
               cprintf("- Got all rare items! - Press a key ");
               getch();
               break;
            }

            case 'q': break;

            default :
            {  gotoxy(1,23);
               cprintf("\n\r** Invalid entry! Press a key **");
               getch();
               break;
            }
         }
      }
      gotoxy(1,24);
      clrscr();
   }
}



//-----------------------
// This function invert the ordrer of a chain of any size
template<class T> void swapbytes(T chain, int size)
{  T templ;
   templ = new T [size];
   assert(templ);
   if (!assert(templ)) exit(1);
   for (int i = 0; i<size; i++) {templ[i] = chain[i];}
   for (int i = 0; i<size; i++) {chain[i] = templ[size-i];}
   delete [] templ; templ = 0;
}

//-----------------------
//-----------------------
//-----------------------
int main(int argc, char **argv)
{
   char thisfile[255], lBakFn[255], lOutFn[255], kp = ' ';
   long endposit;
   int  filen_len;

   cprintf("\n\rFinal Fantasy 3 SRAM file hacking kit coded by Lord J\n\r");
   cprintf("Credits: decipherer,beta tester: Jumper\n\r");
   cprintf("         decipherer,ROM hacker : CzarDragon\n\r\n\r");
   cprintf("%s\n\r\n\r", APP_VERSION);

   if(argv[1] == 0 || argv[1][0] == '\0');

   // pointer points to nothing
   if(argv[1] == 0 || argv[1][0] == '\0')
   {
      cprintf("usage: ff3h <filename.srm>\n\r\n\r");
      return 0;
   }

   filen_len = strlen(argv[1]);

   strcpy(&thisfile[0],argv[1]);
   strcpy(&lBakFn[0],argv[1]);
   strcpy(&lOutFn[0],argv[1]);

   sprintf(&lBakFn[filen_len-3],"bk\0");
   sprintf(&lOutFn[filen_len-3],"srm\0");

/* char printfile[20];
   sprintf(&printfile[0],"printout.txt");
   ofstream pf(&printfile[0], ios::binary);
*/

   ifstream sramfile;

   sramfile.open(thisfile, ios::binary);  // open file
   sramfile.seekg(0, ios::end);           // last byte of file
   endposit = sramfile.tellg();     // that file is 'endposit' long

   if (endposit <= 0)
   {
      cprintf("File named \"%s\" does not exist\n\r",thisfile);
      return 0;
   }
   else if (endposit == 8192)       // lenght of SRAM associated with Snes9x
   {
      cprintf("File named \"%s\" is probably managed\n\r",thisfile);
      cprintf("by Snes9x, this program is compatible with this sram file\n\r");
   }
   else  // emulators like esnes generate a 32k byte SRAM file, should be compatible...
   {
      cprintf("File named \"%s\" is managed by\n\r",thisfile);
      cprintf("an emulator other than Snes9x, this program\n\r");
      cprintf("may not be compatible with this sram file\n\r");
   }
   cprintf("File is %D bytes long\n\r\n\r**",endposit);


   cprintf("Disclamer:\n\r\n\r");

   cprintf("\"Final Fantasy 3\"(R) and all occurence of related context\n\r");
   cprintf("to its sotfware are registered trademarks of Square Co., Ltd.\n\r\n\r");
   cprintf("The programmers of this utility are not affiliated with Square Co. and\n\r");
   cprintf("are not responsible for any loss or damage of material/sofware of the user.\n\r\n\r");

   cprintf("If you do not agree with this disclaimer, please press <cntr>-c (control+c)\n\r");
   cprintf("If you do agree with this disclaimer, press any key\n\r");

   getch();
   cprintf("\n\r");


   // we beggin hacking the file with the first slot:
   int slotnb = 1;

   gameslot slotno1(slot1_offset,sramfile);
   gameslot slotno2(slot2_offset,sramfile);
   gameslot slotno3(slot3_offset,sramfile);
//cprintf(" *%X* ",slotno2.slotdata[2518]);getch(); // the last bug
   sramdata extradata(sramfile);
//cprintf(" *%X* ",slotno2.slotdata[2518]);getch(); // the last bug

   char ch = ' ';
   while ( ((kp!='q')||(kp!='s')) && ch !='y' )
   {
      clrscr();
      gotoxy(22,1);
      cprintf("** FF3H's main menu **");
      gotoxy(22,10);
      cprintf("[1] Select game slot to edit: current is #%d",slotnb);
      gotoxy(22,12);
      cprintf("[2] Hack players");
      gotoxy(22,14);
      cprintf("[3] Hack general data");
      gotoxy(22,16);
      cprintf("[4] Advanced hacking");
      gotoxy(22,18);
      cprintf("[s] Save and quit");
      gotoxy(22,20);
      cprintf("[q] Cancel and quit");


      kp = getch();
      switch(kp)
      {
         case '1':
         {
            gotoxy(1,23);
            cprintf("- Changing slot number - Enter new slot number: ");
            slotnb = getche() - 48;
            if ((slotnb>3) || (slotnb<1)) slotnb=1;
            break;
         }

         case '2':
         {
            if (slotnb==1) submenu1(slotno1);
            else if (slotnb==2) submenu1(slotno2);
            else if (slotnb==3) submenu1(slotno3);
            else slotnb=1;
            break;
         }

         case '3':
         {
            if (slotnb==1) submenu2(slotno1);
            else if (slotnb==2) submenu2(slotno2);
            else submenu2(slotno3);
            break;
         }

         case '4':
         {
            if (slotnb==1) submenu3(slotno1,extradata);
            else if (slotnb==2) submenu3(slotno2,extradata);
            else submenu3(slotno3,extradata);
            break;
         }

         case 's': break;
         case 'q': break;

         default :
         {
            gotoxy(1,24);
            cprintf("\n\r** Invalid entry! Press a key **");
            getch();
            break;
         }
      }

      if (kp=='s')
      {
         gotoxy(1,24);
         cprintf("- Saving modification of all slots - [y]/[n] ");
         ch=getche();
         if (ch=='y')
         {
            unsigned char lOrigFileBuf[0x2000];
            ofstream lBakFile(lBakFn, ios::binary);
            sramfile.seekg(0, ios::beg);

            sramfile.read((char *)lOrigFileBuf, 0x2000);
            lBakFile.write((char *)lOrigFileBuf, 0x2000);

            lBakFile.close();

            sramfile.close();

            ofstream lOutFile(lOutFn, ios::binary);
            lOutFile.write((char*)slotno1.slotdata,slot_lenght*bytesize);
            lOutFile.write((char*)slotno2.slotdata,slot_lenght*bytesize);
            lOutFile.write((char*)slotno3.slotdata,slot_lenght*bytesize);
            lOutFile.write((char*)extradata.data,int(extradata.xtralenght));
            lOutFile.close();

            clrscr();
            cprintf("\n\rOriginal file saved as %s\n\r", lBakFn);
            cprintf("Modified file saved as %s\n\r\n\r", lOutFn);

            break;
         }
         // debug: not working/saving yet
//       extradata.writesram(sramfile);
      }
      else if (kp=='q')
      {
         gotoxy(1,23);
         cprintf("- Quit without saving? - [y]/[n] ");
         ch=getche();
         if (ch=='y')
         {
            clrscr();
            sramfile.close();
            break;
         }
      }
   }

// cprintf("\n\rThanks for using FF3 hacker... lord_j@hotmail.com\n\r");
   dispEndCreditsFancy();

   return 0; // that's the end folks
}

/**********************************************************/
// Credits: displays credits, extra fancy overkilled special fx!!
/**********************************************************/
void dispEndCreditsFancy(void)
{
   char *end1 = "Thanks for using FF3us/FF6j SRAM hacking kit...";
   char *end3 = "www.angelfire.com/pq/jumparound";
   char *end2 = "lord_j@hotmail.com";
// int flashCycle[5] = { 7, 15, 7, 8, 0 };
   // more static
// int flashCycle[18] = { 0,8,0,8,7,15, 8,15,0,15,7,15, 0,8,0,8,8,7 };
   // even more static
// int flashCycle[18] = { 0,8,0,8,0,0, 8,15,0,0,7,15, 0,8,0,8,0,7 };
   // no static
   int flashCycle[18] = { 0,15,0,0,0,0, 0,0,0,15,0,15, 0,0,0,8,7,15 };

   cprintf("%s%s%s",endl,end1,endl);
   int yPos = wherey()-1;

// meltdown flash
/* for(long n=0;n<40000000;n++);
   for(int i =0; i<5; i++)
   {
      gotoxy(1,yPos);
      clreol();
      textcolor(flashCycle[i]);
      cprintf("%s%s",end3,endl);
      for(long n=0;n<35000000;n++);
   }
   textcolor(7);
*/
   int remaining=strlen(end2);

   int xPos = 0;
   for(int i=0; i<strlen(end2); i++)
   {
      gotoxy(1,yPos+1);
      clreol();
      textcolor(flashCycle[i]);
      cprintf("%s%s",end3,endl);
      textcolor(7);

      for(int j=80; j>xPos; j--)
      {
         gotoxy(j,yPos+2);
         putch(end2[i]);
         clreol();
//       for(long n=0;n<300000;n++);
         for(long n=0;n<500000;n++);
      }
      xPos++;
   }
   cprintf("%s",endl);
// xPos=wherex();
// yPos=wherey();
}
